Package: Rcwl
Title: An R interface to the Common Workflow Language
Version: 1.28.0
Authors@R: c(person("Qiang", "Hu", email = "qiang.hu@roswellpark.org", role = c("aut", "cre")),
	     person("Qian", "Liu", email = "qian.liu@roswellpark.org", role = c("aut")))
Description: The Common Workflow Language (CWL) is an open standard for development of data analysis workflows that is portable and scalable across different tools and working environments. Rcwl provides a simple way to wrap command line tools and build CWL data analysis pipelines programmatically within R. It increases the ease of usage, development, and maintenance of CWL pipelines.
Depends: R (>= 3.6), yaml, methods, S4Vectors
Imports: utils, stats, BiocParallel, batchtools, DiagrammeR, shiny,
        R.utils, codetools, basilisk
License: GPL-2 | file LICENSE
Encoding: UTF-8
Suggests: testthat, knitr, rmarkdown, BiocStyle
VignetteBuilder: knitr
RoxygenNote: 7.3.1
biocViews: Software, WorkflowStep, ImmunoOncology
StagedInstall: no
Config/Bioconductor/UnsupportedPlatforms: windows
git_url: https://git.bioconductor.org/packages/Rcwl
git_branch: RELEASE_3_23
git_last_commit: d4c58a5
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:08:54 UTC; biocbuild
Author: Qiang Hu [aut, cre],
  Qian Liu [aut]
Maintainer: Qiang Hu <qiang.hu@roswellpark.org>

# Rcwl

The Rcwl package can be a simple and user-friendly way to manage command line tools and build data analysis pipelines in R using Common Workflow Language (CWL).

## Installation

The package can be installed from Bioconductor (>= 3.9):

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("Rcwl")
	
# Or from github
BiocManager::install("rworkflow/Rcwl")
```

## Hello world!
``` r
library(Rcwl)
inputs <- InputParamList(
    InputParam(id = "sth")
)
echo <- cwlProcess(baseCommand = "echo", inputs)
echo$sth <- "Hello World!"
res <- runCWL(echo)
```

## User Guide

``` r
vignette(package = "Rcwl")
```

#' Rcwl conda environment
#'
#' Rcwl conda envrionment to install `cwltool` by basilisk.
#' @importFrom basilisk BasiliskEnvironment
#' @export
env_Rcwl <- basilisk::BasiliskEnvironment("env_Rcwl", pkgname="Rcwl",
                                          packages = "python==3.11",
                                          pip = "cwltool==3.1.20230719185429")

#' install udocker
#'
#' To download and install udocker for python3.
#'
#' @param version The version of udocker.
#' @importFrom R.utils createLink
#' @export
install_udocker <- function(version = "1.3.4"){
    stopifnot(.Platform$OS.type != "windows")

    if(!file.exists(Sys.which("cwltool"))){
        cl <- basiliskStart(env_Rcwl)
        on.exit(basiliskStop(cl))
    }
    binPath <- Sys.which("cwltool")
    
    download.file(paste0("https://github.com/indigo-dc/udocker/releases/download/", version, "/udocker-", version, ".tar.gz"),
                  file.path(dirname(binPath), "udocker.tar.gz"))
    untar(file.path(dirname(binPath), "udocker.tar.gz"), exdir = dirname(dirname(binPath)))
    
    system(paste0(dirname(dirname(binPath)), "/udocker-", version, "/udocker/udocker install"))
    createLink(file.path(dirname(binPath), "udocker"),
               file.path(dirname(dirname(binPath)), "udocker", "udocker"), overwrite = TRUE)
    udocker_path <- Sys.which("udocker")
    message("udocker installed:", "\n", udocker_path)
}

#' CWL requirements functions

#' @name cwl-requirements
#' @rdname cwl-requirements
#' @description requireDocker: If a workflow component should be run
#'     in a Docker container, this function specifies how to fetch or
#'     build the image.
#' @param docker Character. Specify a Docker image to retrieve using
#'     docker pull.
#' @param Load Character. Specify a HTTP URL from which to download a
#'     Docker image using docker load.
#' @param File Character. Supply the contents of a Dockerfile which will
#'     be built using docker build.
#' @param Import Character. Provide HTTP URL to download and gunzip a
#'     Docker images using `docker import.
#' @param ImageId Character. The image id that will be used for docker
#'     run. May be a human-readable image name or the image identifier
#'     hash. May be skipped if dockerPull is specified, in which case
#'     the dockerPull image id must be used.
#' @param OutputDir Character. Set the designated output directory to a
#'     specific location inside the Docker container.
#' @details More details about `requireDocker`, see:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#DockerRequirement
#' @return requireDocker: A list of docker requirement to fetch or
#'     build the image.
#' @export

requireDocker <- function(docker = NULL, Load = NULL, File = NULL,
                          Import = NULL, ImageId = NULL,
                          OutputDir = NULL){
    req <- list(class = "DockerRequirement",
                dockerPull = docker,
                dockerLoad = Load,
                dockerFile = File,
                dockerImport = Import,
                dockerImageId = ImageId,
                dockerOutputDirectory = OutputDir)
    req <- req[lengths(req) > 0]
    return(req)
}

#' @rdname cwl-requirements
#' @description requireJS: Indicates that the workflow platform must
#'     support inline Javascript expressions. If this requirement is
#'     not present, the workflow platform must not perform expression
#'     interpolatation.
#' @param expressionLib optional list. Additional code fragments that
#'     will also be inserted before executing the expression
#'     code. Allows for function definitions that may be called from
#'     CWL expressions.
#' @details More details about `requireJS`, see:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#InlineJavascriptRequirement
#' @return requireJS: A list of inline Javascript requirement.
#' @export

requireJS <- function(expressionLib = list()){
    req <- list(class = "InlineJavascriptRequirement",
                expressionLib = expressionLib)
    req <- req[lengths(req) > 0]
    return(req)
}

#' @rdname cwl-requirements
#' @description requireSoftware: A list of software packages that
#'     should be configured in the environment of the defined process.
#' @param packages The list of software to be configured.
#' @details More details about `requireSoftware`, see:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#SoftwareRequirement
#' @return requireSoftware: A list of software requirements.
#' @export

requireSoftware <- function(packages = list()){
    req <- list(class = "SoftwareRequirement",
                packages = packages)
    req <- req[lengths(req) > 0]
    return(req)
}

#' @rdname cwl-requirements
#' @description SoftwarePackage from anaconda.
#' @param package The software name.
#' @param source The source of software in anaconda. `bioconda` is
#'     used by default.
#' @param version The version of software.
#' @details More details about `requireSoftware`, see:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#SoftwarePackage
#' @return A list of software package.
#' @export
condaPackage <- function(package, source="bioconda", version=NULL){
    sp <- list(package = package,
               version = version,
               specs = list(paste0("https://anaconda.org/", source, "/", package)))
    sp <- sp[lengths(sp)>0]
    ## sp <- list(sp)
    ## names(sp) <- package
    return(sp)
}

#' @rdname cwl-requirements
#' @description InitialWorkDirRequirement: Define a list of files and
#'     subdirectories that must be created by the workflow platform in
#'     the designated output directory prior to executing the command
#'     line tool.
#' @param listing The list of files or subdirectories that must be
#'     placed in the designated output directory prior to executing
#'     the command line tool.
#' @details More details about `requireInitialWorkDir`, See:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#InitialWorkDirRequirement
#' @return requireInitialWorkDir: A list of initial work directory requirements. 
#' @export

requireInitialWorkDir <- function(listing = list()){
    req <- list(class = "InitialWorkDirRequirement",
                listing = listing)
    req <- req[lengths(req) > 0]
    return(req)
}

#' @rdname cwl-requirements
#' @description: Dirent: Define a file or subdirectory that must be
#'     placed in the designated output directory prior to executing
#'     the command line tool. May be the result of executing an
#'     expression, such as building a configuration file from a
#'     template.
#' @param entryname Character or Expression. The name of the file or
#'     subdirectory to create in the output directory. The name of the
#'     file or subdirectory to create in the output directory. If
#'     entry is a File or Directory, the entryname field overrides the
#'     value of basename of the File or Directory object. Optional.
#' @param entry Charactor or expression. Required.
#' @param writable Logical. If true, the file or directory must be
#'     writable by the tool. Changes to the file or directory must be
#'     isolated and not visible by any other CommandLineTool
#'     process. Default is FALSE (files and directories are
#'     read-only). Optional.
#' @details More details about `Dirent`,
#'     See:https://www.commonwl.org/v1.0/CommandLineTool.html#Dirent
#' @return Dirent: A list.
#' @export
#' 
Dirent <- function(entryname = character(), entry,
                   writable = FALSE){
    list(entryname = entryname,
         entry = entry,
         writable = writable)
}

#' @rdname cwl-requirements
#' @description Create manifest for configure files.
#' @param inputID The input ID from corresponding `InputParam`.
#' @param sep The separator of the input files in the manifest config.
#' @export
#' @examples
#' p1 <- InputParam(id = "ifiles", type = "File[]?", position = -1)
#' CAT <- cwlProcess(baseCommand = "cat",
#'        requirements = list(requireDocker("alpine"), requireManifest("ifiles"), requireJS()),
#'        arguments = list("ifiles"),
#'        inputs = InputParamList(p1))
#' 
requireManifest <- function(inputID, sep = "\\n"){
    js <- paste0("${var x='';for(var i=0;i<inputs.", inputID,
                 ".length;i++){x+=inputs.", inputID, "[i].path+'",
                 sep, "'}return(x)}")

    req1 <- requireInitialWorkDir(
        list(Dirent(entryname = inputID,
                    entry = js)))
    return(req1)
}

#' @rdname cwl-requirements
#' @return requireSubworkflow: A SubworkflowFeatureRequirement list.
#' @export
requireSubworkflow <- function(){
    list(class = "SubworkflowFeatureRequirement")
}

#' @rdname cwl-requirements
#' @return rquireScatter: A ScatterFeatureRequirement list.
#' @export
requireScatter <- function(){
    list(class = "ScatterFeatureRequirement")
}

#' @rdname cwl-requirements
#' @return requireMultipleInput: A MultipleInputFeatureRequirement list.
#' @export
requireMultipleInput <- function(){
    list(class = "MultipleInputFeatureRequirement")
}

#' @rdname cwl-requirements
#' @return requireStepInputExpression: A StepInputExpressionRequirement list.
#' @export
requireStepInputExpression <- function(){
    list(class = "StepInputExpressionRequirement")
}

#' @rdname cwl-requirements
#' @param envlist A list of environment variables.
#' @return requireEnvVar: A EnvVarRequirementlist.
#' @export
requireEnvVar <- function(envlist){
    list(class = "EnvVarRequirement",
         envDef = envlist)
}

#' @rdname cwl-requirements
#' @param rscript An R script to run.
#' @return A requirement list with Rscript as manifest entry.
#' @export
requireRscript <- function(rscript){
    rs <- paste0(readLines(rscript), collapse = "\n")
    req1 <- requireInitialWorkDir(
        list(Dirent(entryname = basename(rscript),
                    entry = rs)))
    return(req1)
}

#' @rdname cwl-requirements
#' @param coresMin Minimum reserved number of CPU cores (default is
#'     1).
#' @param coresMax Maximum reserved number of CPU cores.
#' @param ramMin Minimum reserved RAM in mebibytes (2**20) (default is
#'     256).
#' @param ramMax Maximum reserved RAM in mebibytes (2**20)
#' @param tmpdirMin Minimum reserved filesystem based storage for the
#'     designated temporary directory, in mebibytes (2**20) (default
#'     is 1024).
#' @param tmpdirMax Maximum reserved filesystem based storage for the
#'     designated temporary directory, in mebibytes (2**20).
#' @param outdirMin Minimum reserved filesystem based storage for the
#'     designated output directory, in mebibytes (2**20) (default is
#'     1024).
#' @param outdirMax Maximum reserved filesystem based storage for the
#'     designated output directory, in mebibytes (2**20).
#' @return ResourceRequirement: A ResourceRequirement list.
#' @export
requireResource <- function(coresMin = NULL, coresMax = NULL,
                            ramMin = NULL, ramMax = NULL,
                            tmpdirMin = NULL, tmpdirMax = NULL,
                            outdirMin = NULL, outdirMax = NULL){
    req1 <- list(class = "ResourceRequirement",
                 coresMin = coresMin, coresMax = coresMax,
                 ramMin = ramMin, ramMax = ramMax,
                 tmpdirMin = tmpdirMin, tmpdirMax = tmpdirMax,
                 outdirMin = outdirMin, outdirMax = outdirMax)
    .removeEmpty(req1)
}

#' @rdname cwl-requirements
#' @return ShellCommandRequirement: A ShellCommandRequirement list.
#' @export
requireShellCommand <- function(){
    list(class = "ShellCommandRequirement")
}

#' @rdname cwl-requirements
#' @description requireShellScript: create shell script to work dir.
#' @param script Shell script.
#' @return requireShellScript: Initial directory with shell script.
#' @export
requireShellScript <- function(script){
    entry <- Dirent(entryname = "script.sh", entry = script)
    requireInitialWorkDir(listing = list(entry))
}

#' @rdname cwl-requirements
#' @param shell Default shell.
#' @param script script.sh
#' @return baseCommand for shell script
#' @export
ShellScript <- function(shell = "bash", script = "script.sh"){
    c(shell, script)
}

#' @rdname cwl-requirements
#' @description CondaTool: create dockerfile for tools.
#' @param tools A character vector for tools to install by conda.
#' @return CondaTool: Dockerfile
#' @export
CondaTool <- function(tools){
    dockerfile <- paste0("
FROM continuumio/miniconda3

RUN conda config --add channels r
RUN conda config --add channels bioconda
RUN conda config --add channels conda-forge

RUN conda install -y ", paste(tools, collapse = " "),
"\n")
    return(dockerfile)
}

#' @rdname cwl-requirements
#' @description requireNetwork: Whether a process requires network
#'     access.
#' @param networkAccess TRUE or FALSE.
#' @return requireNetwork: a list of NetworkAccess requirement.
#' @export
requireNetwork <- function(networkAccess = TRUE){
    list(class = "NetworkAccess",
         networkAccess = networkAccess)
}

#' install cwltool
#' 
#' To download and install cwltool using basilisk
#' @export
install_cwltool <- function(){
    cl <- basiliskStart(env_Rcwl)
    basiliskStop(cl)
    return(Sys.which("cwltool"))
}

.rmDList <- function(reqList){
    if(length(reqList) > 0){
        cs <- unlist(lapply(reqList, function(x)x$class))
        if("DockerRequirement" %in% names(reqList)){
            reqList <- reqList[-match("DockerRequirement", names(reqList))]
        }else if( "DockerRequirement" %in% cs){
            reqList <- reqList[-match("DockerRequirement", cs)]
        }
    }
    return(reqList)
}

.rmDocker <- function(cwl){
    requirements(cwl) <- .rmDList(requirements(cwl))
    hints(cwl) <- .rmDList(hints(cwl))
    return(cwl)
}

## Write R function into Rscript
#' @importFrom R.utils commandArgs
#' @importFrom codetools findGlobals
#' 
writeFun <- function(cwl, prefix, outdir, libPaths = TRUE){
    Fname <- ifelse(is.null(prefix) | prefix=="cwl", basename(tempfile()), prefix)
    if(length(cwl@id) > 0){
        file <- file.path(outdir, paste0(cwl@id, ".R"))
    }else{        
        file <- file.path(outdir, paste0(Fname, ".R"))
    }
    funName <- sub(".R", "", basename(file))
    assign(funName, baseCommand(cwl))
    types <- lapply(inputs(cwl), function(x)x@type)
    comArg <- c("suppressPackageStartupMessages(library(R.utils))",                
                "args <- commandArgs(trailingOnly = TRUE, asValues = TRUE)")
    ## add user libPaths
    if(libPaths){
        libs <- .libPaths()
        libs <- paste0("c('", paste(libs, collapse = "','"), "')")
        comArg <- c(paste0(".libPaths(", libs, ")"), comArg)
    }
    write(comArg, file = file)

    for(i in seq_along(types)){
        tn <- names(types)[i]
        if(types[[i]] == "int"){
            write(paste0("args[[\"", tn, "\"]] <- as.integer(args[[\"", tn, "\"]])"),
                  file = file, append = TRUE)
        }else if(types[[i]] %in% c("long", "float", "double")){
            write(paste0("args[[\"", tn, "\"]] <- as.numeric(args[[\"", tn, "\"]])"),
                  file = file, append = TRUE)
        }
    }
    ## didn't work
    ff <- findGlobals(baseCommand(cwl))
    ff <- ff[!grepl("package|namespace", sapply(ff, find))]
    if(length(ff) > 0){
        sapply(ff, dump, file = file, append = TRUE)
    }
    dump(funName, file = file, append = TRUE)
    write(paste0("do.call(", funName, ", args)"),
          file = file, append = TRUE)
    return(file)
}

cwlToList <- function(cwl, docker = TRUE, prefix, outdir){
    stopifnot(is(cwl, "cwlProcess"))
    if(!docker) cwl <- .rmDocker(cwl)
    if(is(baseCommand(cwl), "function")){
        rfile <- writeFun(cwl, prefix, outdir)
        bc <- c("Rscript", rfile)
    }else{
        bc <- baseCommand(cwl)
    }
    CL <- list(cwlVersion = cwlVersion(cwl),
               class = cwlClass(cwl),
               baseCommand = bc,
               requirements = cwl@requirements,
               hints = cwl@hints,
               arguments = cwl@arguments,
               id = cwl@id,
               label = cwl@label,
               doc = cwl@doc,
               inputs = as.listInputs(inputs(cwl)),
               outputs = as.listOutputs(outputs(cwl)),
               stdin = cwl@stdin,
               stdout = cwl@stdout,
               expression = cwl@expression)
    CL <- c(CL, cwl@extensions)
    ## CL$requirements <- .removeEmpty(CL$requirements)
    CL <- .removeEmpty(CL)
    if (!"inputs" %in% names(CL) ) {  ## if no input parameters, add space holder with an empty list before "outputs".
        CL$inputs <- list()
        pos <- grep("outputs", names(CL)) 
        CL <- c(CL[seq(pos-1)], CL["inputs"], CL[seq(pos, length(CL)-1)])
    }
    if(cwlClass(cwl) == "Workflow"){
        CL <- c(CL, list(steps = as.listSteps(cwl@steps)))
        ## remove inputBinding
        for(i in seq(CL$inputs)){
            CL$inputs[[i]]$inputBinding <- NULL
            if("inputBinding" %in% names(CL$inputs[[i]]$type)){
                CL$inputs[[i]]$type$inputBinding <- NULL
            }
        }
    }else if (cwlClass(cwl) == "ExpressionTool") {
        for(i in seq(CL$inputs)){
            CL$inputs[[i]]$inputBinding <- NULL
        }
    }
    if(is.null(CL$outputs)) CL$outputs <- list()
    return(CL)
}

## Nested steps
allRun <- function(cwl){
    Steps <- steps(cwl)
    Run <- c()
    for(i in seq(Steps)){
        nm1 <- names(Steps)[i]
        run1 <- Steps[[i]]@run

        if(is(run1, "cwlProcess") & !is(run1, "cwlWorkflow")){
            nn <- names(Run)
            Run <- c(Run, run1)
            names(Run) <- c(nn, nm1)
        }else if(is(run1, "cwlWorkflow")){
            ## record cwlWorkflow
            nn <- names(Run)
            Run <- c(Run, run1)
            names(Run) <- c(nn, nm1)
            ## recursive
            Run <- c(Run, allRun(run1))
        }
    }
    return(Run)
}

#' Write CWL
#' 
#' write `cwlProcess` to cwl and yml.
#' @param cwl A `cwlProcess` or `cwlWorkflow` object.
#' @param prefix The prefix of `.cwl` and `.yml` files to be generated.
#' @param outdir The output directory for the `.cwl` and `.yml` files. 
#' @param docker Whether to use docker.
#' @param libPaths Whether to add local R libaray paths to R script.
#' @param ... Other options from `yaml::write_yaml`.
#' @import yaml
#' @export
#' @return A CWL file and A YML file.
#' @examples
#' input1 <- InputParam(id = "sth")
#' echo <- cwlProcess(baseCommand = "echo",
#'                  inputs = InputParamList(input1))
#' writeCWL(echo)
writeCWL <- function(cwl, prefix = deparse(substitute(cwl)),
                     outdir = tempfile(),
                     docker = TRUE, libPaths = TRUE, ...){
    if (!dir.exists(outdir)) dir.create(outdir, recursive = TRUE)
    stopifnot(is(cwl, "cwlProcess"))
    ## logical to true/false
    handlers  <-  list(
        logical = function(x) {
            result <- ifelse(x, "true", "false")
            class(result) <- "verbatim"
            return(result)
        }
    )
    yml <- .removeEmpty(.cwl2yml(cwl))

    .R2cwl <- function(x, prefix, outdir){
        rfile <- writeFun(x, prefix, outdir = outdir, libPaths)
        baseCommand(x) <- "Rscript"
        requirements(x) <- c(list(requireRscript(rfile)), requirements(x))
        arguments(x) <- c(list(basename(rfile)), arguments(x))
        return(x)
    }
    
    if(cwlClass(cwl) == "Workflow") {
        Runs <- allRun(cwl)
        lapply(seq(Runs), function(i){
            cfile <- paste0(file.path(outdir, 
                                      names(Runs)[i]), ".cwl")
            if (is(baseCommand(Runs[[i]]), "function")) {
                Runs[[i]] <- .R2cwl(Runs[[i]], names(Runs)[i], outdir)
            }
            write_yaml(cwlToList(Runs[[i]], docker,
                                 prefix = sub(".cwl", "", basename(cfile)),
                                 outdir),
                       file = cfile,
                       handlers = handlers, ...)
        })
        
        ## NOTE: Now nested pipelines and related tools are all written
        ## in the same directory. Future conflict may rise when  nested
        ## pipelines are using the same tool but with different options,
        ## there will be different "id" for each tool. Or we can later add
        ## a prefix of the pipeline name on that specific tool. 2/12/2012
        
        ## for(i in seq(cList$steps)){
        ##     if(!grepl("^/", cList$steps[[i]]$run)){
        ##         cList$steps[[i]]$run <- file.path(outdir,
        ##                                           cList$steps[[i]]$run)
        ##     }
    }else if(is(baseCommand(cwl), "function")){
        cwl <- .R2cwl(cwl, prefix, outdir)
    }
    cList <- cwlToList(cwl, docker, prefix, outdir)
    cwlout <- file.path(outdir, paste0(prefix, ".cwl"))
    ymlout <- file.path(outdir, paste0(prefix, ".yml"))
    write_yaml(cList, file = cwlout, handlers = handlers, ...)
    if (!length(yml)) {
        writeLines("{}", con = ymlout)
    } else {
        write_yaml(yml, file = ymlout, handlers = handlers, ...)
    }
    return(c(cwlout = cwlout, ymlout = ymlout))
}

.cwl2yml <- function(cwl){
    lapply(inputs(cwl), function(x) {

        if(length(x@value) > 0) {
            v <- x@value
        }else if(length(x@default) > 0){
            v <- x@default
        }else{
            v <- NULL
        }
        if(is(x@type, "InputArrayParam")){
            Type <- x@type@items
        }else{
            Type <- x@type
        }        
        if(is(v, "character") && any(Type == "int")){
            v <- as.integer(v)
        }else if(is(v, "character") && any(Type == "boolean")){
            v <- as.logical(v)
        }
        if(length(x@format)!=0){
            v <- c(format = x@format, v)
        }
        v
    })
}

.slot2list <- function(x) {
    mapply(function(y) slot(x, y),
           slotNames(class(x)),
           SIMPLIFY = FALSE)
}

.removeEmpty <- function(L) {
    L <- L[L != ""]
    L[lengths(L) > 0]
}

as.listInputs <- function(Inputs){
    alist <- lapply(Inputs, .slot2list)

    for(i in seq(alist)){
        if(is(alist[[i]]$type, "InputArrayParam")){
            atype <- .slot2list(alist[[i]]$type)
            atype <- .removeEmpty(atype)
            atype$inputBinding <- .removeEmpty(atype$inputBinding)
            alist[[i]]$type <- atype
        }
        
        if(alist[[i]]$inputBinding$position == 0){
            alist[[i]]$inputBinding$position <- NULL
        }else if(alist[[i]]$inputBinding$position < 0){
            alist[[i]]$inputBinding <- NULL
        }

        alist[[i]]$inputBinding <- .removeEmpty(alist[[i]]$inputBinding)
        alist[[i]]$value <- NULL
        alist[[i]]$id <- NULL
        alist[[i]] <- .removeEmpty(alist[[i]])
    }
    return(alist)
}

as.listOutputs <- function(Outputs){
    olist <- lapply(Outputs, .slot2list)
    for(i in seq(olist)){
        olist[[i]]$id <- NULL
        if(is(olist[[i]]$type, "OutputArrayParam")){
            otype <- .removeEmpty(.slot2list(olist[[i]]$type))
            otype$outputBinding <- .removeEmpty(otype$outputBinding)
            olist[[i]]$type <- otype
        }
        olist[[i]]$outputBinding <- .removeEmpty(olist[[i]]$outputBinding)
        olist[[i]] <- .removeEmpty(olist[[i]])        
    }
    return(olist)
}


as.listSteps <- function(Steps){
    slist <- lapply(Steps, function(st) {
        sIns <- lapply(st@In, function(x) {
            ilist1 <- .slot2list(x)
            ilist1 <- ilist1[lengths(ilist1) > 0]
            ilist1$id <- NULL
            if(all(names(ilist1) == "source")){
                ilist1 <- ilist1$source
            }
            ilist1
        })

        if(is(st@run, "cwlProcess")){
            run <- paste0(st@id, ".cwl")
        }else{
            run <- st@run
        }
        .removeEmpty(
            list(run = run,
                 "in" = sIns,
                 out = st@Out,
                 scatter = st@scatter,
                 scatterMethod = st@scatterMethod,
                 label = st@label,
                 doc = st@doc,
                 requirements = st@requirements,
                 hints = st@hints,
                 when = st@when)
        )
    })
    return(slist)
}

#' Parameters for CWL
#' 
#' The main CWL parameter class and constructor for command
#' tools. More details:
#' https://www.commonwl.org/v1.0/CommandLineTool.html
#' @rdname cwlProcess
#' @importFrom S4Vectors SimpleList
#' @import methods
#' @import utils
#' @param cwlVersion CWL version
#' @param cwlClass "CommandLineTool"
#' @param baseCommand Specifies the program or R function to execute
#' @param requirements A list of requirements that apply to either the
#'     runtime environment or the workflow engine that must be met in
#'     order to execute this process.
#' @param hints Any or a list for the workflow engine.
#' @param arguments Command line bindings which are not directly
#'     associated with input parameters.
#' @param id The unique identifier for this process object.
#' @param label A short, human-readable label of this process object.
#' @param doc A documentation string for this object, or an array of
#'     strings which should be concatenated.
#' @param inputs A object of `InputParamList`.
#' @param outputs A object of `OutputParamList`.
#' @param stdout Capture the command's standard output stream to a
#'     file written to the designated output directory.
#' @param stdin A path to a file whose contents must be piped into the
#'     command's standard input stream.
#' @param expression Javascripts for ExpressionTool class.
#' @param extensions A list of extensions and metadata
#' @param intent An identifier for the type of computational
#'     operation, of this Process.
#' @export
#' @details https://www.commonwl.org/v1.0/CommandLineTool.html
#' @return A `cwlProcess` class object.
#' @examples
#' input1 <- InputParam(id = "sth")
#' echo <- cwlProcess(baseCommand = "echo", inputs = InputParamList(input1))
cwlProcess <- function(cwlVersion = "v1.0",
                       cwlClass = "CommandLineTool",
                       baseCommand = character(),
                       requirements = list(), hints = list(),
                       arguments = list(), id = character(),
                       label = character(), doc = character(),
                       inputs = InputParamList(),
                       outputs = OutputParamList(),
                       stdout = character(), stdin = character(),
                       expression = character(), extensions = list(),
                       intent = list()){
    new("cwlProcess", cwlVersion = cwlVersion, cwlClass = cwlClass,
        id = id, label = label, baseCommand = baseCommand,
        requirements = requirements, hints = hints, doc = doc,
        arguments = arguments, inputs = inputs, outputs = outputs,
        stdout = stdout, stdin = stdin, expression = expression,
        extensions = extensions, intent = intent)
}

#' cwlStep function
#' @description Constructor function for `cwlStep` object.
#' @param id A user-defined unique identifier for this workflow step.
#' @param run A `cwlProcess` object for command line tool, or path to
#'     a CWL file.
#' @param In A list of input parameters which will be constructed into
#'     `stepInParamList`.
#' @param Out A list of outputs.
#' @param scatter character or a list. The inputs to be scattered.
#' @param scatterMethod required if scatter is an array of more than
#'     one element. It can be one of "dotproduct",
#'     "nested_crossproduct" and "flat_crossproduct".
#' @param label A short, human-readable label of this object.
#' @param doc A documentation string for this object, or an array of
#'     strings which should be concatenated.
#' @param requirements Requirements that apply to either the runtime
#'     environment or the workflow engine.
#' @param hints Hints applying to either the runtime environment or
#'     the workflow engine.
#' @param when If defined, only run the step when the expression
#'     evaluates to true. If false the step is skipped.
#' @export
#' @return An object of class `cwlStep`.
#' @details For more details:
#'     https://www.commonwl.org/v1.0/Workflow.html#WorkflowStep
#' @examples
#' s1 <- cwlStep(id = "s1")
#' @seealso \code{\link{cwlWorkflow}}
cwlStep <- function(id, run = cwlProcess(),
                    In = list(), Out = list(),
                    scatter = character(), scatterMethod = character(),
                    label = character(),
                    doc = character(),
                    requirements = list(),
                    hints = list(),
                    when = character()) {

    ## add defaults to In
    ins <- names(inputs(run))
    inL <- paste0(id, "_", ins)
    names(inL) <- ins
    if(length(In)>0){
        inL[match(names(In), ins)] <- In
    }
    ## remove optional/default
    df <- unlist(lapply(inputs(run),function(x){
        f1 <- FALSE
        if(is(x@type, "character")){
            f1 <- grepl("\\?", x@type)
        }
        f1 | length(x@default)!=0
    }))
    if(any(df)){
        df <- setdiff(names(inL)[df], names(In))
        if(length(df)>0){
            inL <- inL[-match(df, names(inL))]
        }
    }
    In <- inL

    if(is(run, "cwlProcess")){
        if(length(ins) > 0){
            stopifnot(names(In) %in% names(inputs(run)))
        }
        sout <- as.list(names(outputs(run)))
    }else if(is(run, "character")){
        stopifnot(file.exists(run))
        clist <- read_yaml(run)
        stopifnot(names(In) %in% names(clist$inputs))
        sout <- as.list(names(clist$outputs))
    }
    slist <- list()
    for(i in seq(In)) {
        if(is.list(In[[i]])) {
            si <- stepInParam(id = names(In)[i])
            for(j in seq(In[[i]])){
                slot(si, names(In[[i]])[j]) <- In[[i]][[j]]
            }
        }else{
            si <- stepInParam(id = names(In)[i],
                              source = In[[i]])
        }
        slist[[i]] <- si
    }
    names(slist) <- names(In)
    new("cwlStep",
        id = id,
        run = run,
        In = do.call(stepInParamList, slist),
        Out = sout,
        scatter = scatter,
        scatterMethod = scatterMethod,
        label = label,
        doc = doc,
        requirements = requirements,
        hints = hints,
        when = when)
}


#' stepInputs
#'
#' extract inputs in the format of id_name.
#' @description prepare inputs for workflow from `cwlStep` objects
#' @param stepList a list of `cwlStep` objects.
#' @return InputParamList.
#' @export
stepInputs <- function(stepList){
    ## keep unchanged inputs
    ss <- lapply(stepList, function(s){
        unlist(lapply(s@In, function(x)x@source))
    })
    ss <- unlist(ss)
    ## update ids
    ins <- do.call(c, lapply(stepList, function(x){
        i1 <- inputs(x@run)
        for(i in seq(i1)){
            i1[[i]]@id <- paste0(x@id, "_", i1[[i]]@id)
        }
        names(i1) <- paste0(x@id, "_", names(i1))        
        i1
    }))
    idx <- names(ins) %in% ss
    return(ins[idx])
}


#' stepOutputs
#' 
#' @description prepare outputs for workflow from `cwlStep` objects
#' @param stepList a list of `cwlStep` objects.
#' @return OutputParamList.
#' @export
stepOutputs <- function(stepList){
    os <- lapply(stepList, function(s1){
        lapply(outputs(s1@run), sid = s1@id, function(x, sid){
            OutputParam(id = paste0(sid, "_", x@id), type = x@type,
                        outputSource = paste0(sid, "/", x@id))
        })
        
    })
    outs <- do.call(OutputParamList, unlist(os))
    outs <- outs[-match("output", names(outs))]
    return(outs)
} 

#' run cwlProcess
#' 
#' Execute a cwlProcess object with assigned inputs.
#' @param cwl A `cwlProcess` or `cwlWorkflow` object.
#' @param cwlRunner The path to the `cwltool` or `cwl-runner`. If not
#'     exists, the cwltool package will be installed by `reticulate`.
#' @param outdir Output directory, default is current working
#'     directory.
#' @param cachedir Directory to cache intermediate workflow outputs to
#'     avoid recomputing steps.
#' @param cwlTemp File path to keep intermediate files. If a directory
#'     path is given, the intermediate files will be kept in the
#'     directory. Default is NULL to remove all intermediate files.
#' @param cwlArgs The arguments for `cwltool` or `cwl-runner`. For
#'     example, "--debug" can work with `cwltool` to show debug
#'     information.
#' @param stdout standard output from `system2`.
#' @param stderr standard error from `system2`. By setting it to "",
#'     the detailed running logs will return directly.
#' @param showLog Whether to show log details to standard
#'     out. i.e. stderr = "".
#' @param docker Whether to use docker, or "sigularity" if use
#'     Singularity runtime to run container.
#' @param conda Whether to install packages using conda if
#'     `SoftwareRequirement` is defined.
#' @param yml_prefix The prefix of `.cwl` and `.yml` files that are to
#'     be internally executed.
#' @param yml_outdir The output directory for the `.cwl` and `.yml`
#'     files.
#' @param ... The other options from `writeCWL` and `system2`.
#' @importFrom basilisk basiliskStart basiliskStop
#' @export
#' @return A list of outputs from tools and logs from cwltool.
#' @examples
#' input1 <- InputParam(id = "sth")
#' echo <- cwlProcess(baseCommand = "echo",
#'                  inputs = InputParamList(input1))
#' echo$sth <- "Hello World!"
#' ## res <- runCWL(echo)
runCWL <- function(cwl, outdir = ".", cwlRunner = "cwltool",
                   cachedir = NULL, cwlTemp = NULL, cwlArgs = character(),
                   stdout = TRUE, stderr = TRUE, showLog = FALSE,
                   docker = TRUE, conda = FALSE,
                   yml_prefix = deparse(substitute(cwl)),
                   yml_outdir = tempfile(), ...){
    ## check missing inputs
    yml0 <- .removeEmpty(.cwl2yml(cwl))
    if(length(yml0) < length(inputs(cwl))){
        mis <- setdiff(names(inputs(cwl)), names(yml0))
        ifReq <- rep(TRUE, length(mis))
        for(i in seq_along(mis)){
            type1 <- inputs(cwl)[[mis[i]]]@type
            if(is.character(type1) | is.list(type1)){
                ifReq[i] <- !any(grepl("\\?", type1))
            }
        }
        mis <- mis[ifReq]
        if(length(mis) > 0)
            stop("Input parameter(s): ", paste(mis, collapse = ", "), " not assigned.")
    }
    if(docker == "singularity"){
        cwlArgs <- paste("--singularity", cwlArgs)
        docker <- TRUE
    }else if(docker == "udocker"){
        cwlArgs <- paste("--user-space-docker-cmd=udocker", cwlArgs)
        docker <- TRUE
    }else if(docker == "podman"){
        cwlArgs <- paste("--podman", cwlArgs)
        docker <- TRUE
    }
    if (!dir.exists(yml_outdir)) dir.create(yml_outdir)
    writeCWL(cwl, prefix = yml_prefix, outdir = yml_outdir, docker = docker, ...)

    ## ## check cwltool
    ## ext <- suppressWarnings(system(paste("which", cwlRunner),
    ##                                intern = TRUE))
    ## if(length(ext)==0){
    ##     stop(cwlRunner, " is not found, ",
    ##         "Please install cwltool first!\n",
    ##          "https://github.com/common-workflow-language/cwltool#install")
    ## }
    if(!file.exists(Sys.which(cwlRunner))){
        cl <- basiliskStart(env_Rcwl)
        basiliskStop(cl)
    }
    if(!is.null(cwlTemp)){
        cwlArgs <- paste("--tmpdir-prefix", cwlTemp, cwlArgs)
    }
    if(!is.null(cachedir)){
        cwlArgs <- paste("--cachedir", cachedir, cwlArgs)
    }
    if(showLog){
        stderr <- ""
    }

    if(conda){
        cl <- basiliskStart(env_Rcwl)
        basiliskStop(cl)
        if("SoftwareRequirement" %in% unlist(hints(cwl))){
            req_s <- lapply(hints(cwl),
                            function(x)x[x$class=="SoftwareRequirement"])[[1]]
            pkgs <- lapply(req_s$packages, function(x){
                if(!is.null(x$version)){
                    paste(x$package, x$version, sep="==")
                }else{
                    x$package
                }
            })
            system(paste("conda install -y", paste(pkgs, collapse=" ")))
        }
    }
    
    res <- system2(cwlRunner,
                   args = paste0("--outdir ", outdir, " ", cwlArgs, " ",
                                 file.path(yml_outdir, paste0(yml_prefix, ".cwl ")),
                                 file.path(yml_outdir, paste0(yml_prefix, ".yml"))),
                   stdout = stdout, stderr = stderr, ...)
    ##return(res)
    message(tail(res, 1))
    if(!any(grepl("path", res)) & any(grepl("location", res))){
        path <- read.table(textConnection(res[grep('\"location\":', res)]),
                           stringsAsFactors = FALSE)[,3]
    }else if(any(grepl("path", res))){
        path <- read.table(textConnection(res[grep('\"path\":', res)]),
                           stringsAsFactors = FALSE)[,3]
    }else{
        path <- NULL
    }
    if(stderr == TRUE) {
        if(cwlClass(cwl) == "CommandLineTool"){
            idx <- grep("\\[job", res)
            command <- res[idx[1] : (idx[2]-1)]
        }else{
            command <- NULL
        }
    }else{
        command <- NULL
    }
    SimpleList(command = command,
               output = path,
               logs = res)
}


runFun <- function(idx, cwl, outdir, inputList, paramList = list(), cachedir = NULL, ...){
    library(Rcwl)
    iidx <- names(inputList) %in% names(inputs(cwl))
    if(!all(iidx)){
        warning(paste(names(inputList)[!iidx], collapse = ", "),
                " are not assigned")
    }
    ## change output directory
    sname <- names(inputList[[1]])
    outdir <- file.path(outdir, sname[idx])
    dir.create(outdir, showWarnings = FALSE, recursive = TRUE)
    ## assign inputs
    for(i in seq_along(inputList)){
        input1 <- inputList[[i]][[idx]]
        cwl <- .assignInput(cwl, names(inputList)[i], input1)
    }
    if(length(paramList) > 0){
        for(j in seq_along(paramList)){
            cwl <- .assignInput(cwl, names(paramList)[j], paramList[[j]])
        }
    }
    if(!is.null(cachedir)){
        cachedir <- file.path(cachedir, sname[idx])
    }
    runCWL(cwl, outdir = outdir, cachedir = cachedir, ...)
}

#' run CWL with batchtools
#' 
#' @param cwl A `cwlProcess` or `cwlWorkflow` object.
#' @param outdir Directory to output results
#' @param inputList An input list to run in parallel. The list names
#'     must be in the inputs of cwl. Jobs will be submitted in
#'     parallel for each element in the list. The output directory of
#'     each job will be made using the name of each element under the
#'     `outdir`.
#' @param paramList A parameter list for the cwl. The list names must
#'     be in the inputs of cwl.
#' @param BPPARAM The options for `BiocParallelParam`.
#' @param ... The options from runCWL.
#' @import BiocParallel
#' @import batchtools
#' @export
#' @return Results from computing nodes and logs from cwltool.
runCWLBatch <- function(cwl, outdir = getwd(), inputList, paramList = list(),
                        BPPARAM = BatchtoolsParam(
                            workers = lengths(inputList)[1]), ...){
    nsample <- lengths(inputList)[1]
    if(!dir.exists(outdir)) dir.create(outdir, recursive = TRUE)
    bptry(bplapply(seq(nsample), runFun, BPPARAM = BPPARAM,
                   cwl = cwl, outdir = normalizePath(outdir),
                   inputList = inputList,
                   paramList = paramList, ...))
}

#' run CWL with BiocParallel
#'
#' Submit one CWL object with assigned values with BiocParallel.
#' @param cwl cwl A `cwlProcess` or `cwlWorkflow` object.
#' @param outdir Directory for output results
#' @param BPPARAM The options for `BiocParallelParam`.
#' @param ... The other options from runCWL.
#' @export
#' @return Results from computing nodes and logs from cwltool.
runCWLBP <- function(cwl, outdir, BPPARAM, ...){
    runOne <- function(idx, cwl, outdir, ...){
        library(Rcwl)    
        runCWL(cwl, outdir = outdir, ...)
    }
    bptry(bplapply(1, runOne, cwl, BPPARAM = BPPARAM,
                   outdir=outdir, ...))
}

#' plotCWL
#'
#' Function to plot cwlWorkflow object.
#' @param cwl A cwlWorkflow object to plot
#' @param output A string specifying the output type. An option
#'     inherits from `render_graph` and can also be "mermaid".
#' @param layout Layout from `render_graph`.
#' @param ... other parameters from `mermaid` or `render_graph`
#'     function
#' @importFrom DiagrammeR mermaid
#' @importFrom DiagrammeR create_graph
#' @importFrom DiagrammeR add_nodes_from_table
#' @importFrom DiagrammeR add_edges_from_table
#' @importFrom DiagrammeR render_graph
#' @importFrom stats na.omit
#' @export
#' @return A workflow plot.
#' @examples
#' input1 <- InputParam(id = "sth")
#' echo1 <- cwlProcess(baseCommand = "echo",
#'                   inputs = InputParamList(input1))
#' input2 <- InputParam(id = "sthout", type = "File")
#' echo2 <- cwlProcess(baseCommand = "echo",
#'                   inputs = InputParamList(input2),
#'                   stdout = "out.txt")
#' i1 <- InputParam(id = "sth")
#' o1 <- OutputParam(id = "out", type = "File", outputSource = "echo2/output")
#' wf <- cwlWorkflow(inputs = InputParamList(i1),
#'                    outputs = OutputParamList(o1))
#' s1 <- cwlStep(id = "echo1", run = echo1, In = list(sth = "sth"))
#' s2 <- cwlStep(id = "echo2", run = echo2, In = list(sthout = "echo1/output"))
#' wf <- wf + s1 + s2
#' plotCWL(wf)
plotCWL <- function(cwl, output = "graph", layout = "tree", ...){
    if(output == "mermaid"){
        plotMermaid(cwl, ...)
    }else{
        plotGraph(cwl, output = output, layout = layout, ...)
    }
}

plotMermaid <- function(cwl, ...){
    Inputs <- names(inputs(cwl))
    Outputs <- names(outputs(cwl))
    OutSource <- unlist(lapply(outputs(cwl), function(x)x@outputSource))
    
    Steps <- steps(cwl)
    Snames <- names(Steps)
    ## all nodes
    nodes <- c(Inputs, Outputs, Snames)
    if(length(nodes) > 26){
        nn <- length(nodes) - 26
        NodeID <- c(LETTERS, paste0(LETTERS[seq(nn)], seq(nn)))
    }else{
        NodeID <- LETTERS[seq(length(nodes))]
    }
    names(nodes) <- NodeID
    
    mm <- c("graph TB")
    for(i in seq_along(Steps)){
        s1 <- Steps[[i]]
        sid1 <- names(nodes)[match(Snames[i], nodes)]

        ## inputs
        input1 <- unlist(lapply(s1@In, function(x)x@source))
        mIn <- c()
        for(j in seq_along(input1)){
            if(input1[j] %in% Inputs){
                id1 <- names(nodes)[match(input1[j], nodes)]
                mIn[j] <- paste0(id1, "(", input1[j], ")-->",
                                 sid1, "{", Snames[i], "}")
            }else if(input1[j] %in% OutSource){
                in2os <- names(OutSource)[match(input1[j], OutSource)]
                id1 <- names(nodes)[match(in2os, nodes)]
                mIn[j] <- paste0(id1, "((", in2os, "))-->",
                                 sid1, "{", Snames[i], "}")
            }else{
                sIn <- unlist(strsplit(input1[j], split = "/"))
                id1 <- names(nodes)[match(sIn[1], nodes)]
                mIn[j] <- paste0(id1, "{", sIn[1], "}-->|", sIn[2],
                                 "|", sid1, "{", Snames[i], "}")
            }
        }

        ## outputs
        output1 <- unlist(s1@Out)
        sout1 <- paste(Snames[i], output1, sep = "/")
        mOut <- c()
        for(j in seq_along(output1)){
            if(sout1[j] %in% OutSource){
                o1 <- names(OutSource)[match(sout1[j], OutSource)]
                oid1 <- names(nodes)[match(o1, nodes)]
                mOut[j] <- paste0(sid1, "{", Snames[i], "}", "-->",
                                  oid1, "((", o1, "))")
            }
        }
        mm <- c(mm, mIn, mOut)
    }
    ## remove orphan output nodes
    mm <- na.omit(mm)
    mermaid(paste(mm, collapse = "\n"), ...)
}

plotGraph <- function(cwl, layout = "tree", ...){
    Inputs <- names(inputs(cwl))
    Outputs <- names(outputs(cwl))
    OutSource <- unlist(lapply(outputs(cwl), function(x)x@outputSource))
    
    Steps <- steps(cwl)
    Snames <- names(Steps)
    ## all nodes
    nodes <- c(Inputs, Outputs, Snames)
    if(length(nodes) > 26){
        nn <- length(nodes) - 26
        NodeID <- c(LETTERS, paste0(LETTERS[seq(nn)], seq(nn)))
    }else{
        NodeID <- LETTERS[seq(length(nodes))]
    }
    shape <- rep(c("rectangle", "circle", "diamond"),
                 c(length(Inputs), length(Outputs), length(Snames)))
    ntable <- data.frame(id = NodeID, label = nodes, shape = shape)
    ntable <- data.frame(ntable, id_ext = ntable$id)
    names(nodes) <- NodeID

    etable <- c()
    for(i in seq_along(Steps)){
        s1 <- Steps[[i]]
        sid1 <- names(nodes)[match(Snames[i], nodes)]
        input1 <- unlist(lapply(s1@In, function(x)x@source))
        mIn <- c()
        for(j in seq_along(input1)){
            if(input1[j] %in% Inputs){
                iid1 <- names(nodes)[match(input1[j], nodes)]
                e1 <- data.frame(from  = iid1, to = sid1)
            }else if(input1[j] %in% OutSource){                
                in2os <- names(OutSource)[match(input1[j], OutSource)]
                iid1 <- names(nodes)[match(in2os, nodes)]
                e1 <- data.frame(from = iid1, to = sid1)
            }else{
                sIn <- unlist(strsplit(input1[j], split = "/"))[1]
                iid1 <- names(nodes)[match(sIn[1], nodes)]
                e1 <- data.frame(from = iid1, to = sid1)
            }
            mIn <- rbind(mIn, e1)
        }

        output1 <- unlist(s1@Out)
        sout1 <- paste(Snames[i], output1, sep = "/")
        mOut <- c()
        for(j in seq_along(output1)){
            if(sout1[j] %in% OutSource){
                o1 <- names(OutSource)[match(sout1[j], OutSource)]
                oid1 <- names(nodes)[match(o1, nodes)]
                mOut <- rbind(mOut, data.frame(from = sid1, to = oid1))
             }
        }
        etable <- rbind(etable, rbind(mIn, mOut))
    }

    graph <- create_graph()
    graph <- add_nodes_from_table(graph, ntable, label_col = "label")
    graph <- add_edges_from_table(graph, etable,
                                  from_col = "from", to_col = "to",
                                  from_to_map = "id_ext")
    render_graph(graph, layout = layout, ...)
}

.inputUI <- function(cwl, inputList, upload){
    ilist <- inputs(cwl)
    dList <- lapply(ilist, function(x){
        if(x@inputBinding$prefix != ""){
            label <- paste0(x@id, " (", x@inputBinding$prefix, " ", x@type, ")")
        }else{
            label <- paste0(x@id, " (", x@type, ")")
        }
        if(x@id %in% names(inputList)){
            d <- selectInput(inputId = x@id,
                             label = label,
                             choices = inputList[[x@id]])
        }else{
            if(is(x@type, "InputArrayParam")){
                d <- textAreaInput(inputId = x@id,
                                   label = label,
                                   value = x@default)
            }else if(x@type == "boolean"){
                d <- selectInput(inputId = x@id,
                                 label = label,
                                 choices = list("TRUE" = TRUE, "FALSE" = FALSE))
            }else if(x@type == "int"){
                v <- ifelse(length(x@default) == 0, NA, x@default)
                d <- numericInput(inputId = x@id,
                                  label = label,
                                  value = v)
            }else if(x@type %in% c("string", "File", "Directory")){
                if(x@type == "File" & upload){
                    d <- fileInput(inputId = x@id,
                                   label = label)
                }else{
                    d <- textInput(inputId = x@id,
                                   label = label,
                                   value = x@default)
                }
            }else if(grepl("\\[", x@type)){
                d <- textAreaInput(inputId = x@id,
                                   label = label,
                                   value = x@default)
            }else{
                d <- textInput(inputId = x@id,
                               label = label,
                               value = x @default)
            }
        }
        
        if(length(x@doc) > 0){
            list(d, helpText(x@doc))
        }else{
            d
        }
    })
    dList
}

#' cwlShiny
#'
#' Function to generate shiny app automaticlly for a `cwlProcess`
#' object.
#' @param cwl A cwlProcess object.
#' @param inputList a list of choices for the inputs of cwl
#'     object. The name of the list must match the inputs of the cwl
#'     object.
#' @param upload Whether to upload file. If FALSE, the upload field
#'     will be text input (file path) instead of file input.
#' @param ... More options for `runCWL`.
#' @import shiny
#' @export
#' @return A shiny webapp.
#' @examples
#' input1 <- InputParam(id = "sth")
#' echo <- cwlProcess(baseCommand = "echo", inputs = InputParamList(input1))
#' echoApp <- cwlShiny(echo)

cwlShiny <- function(cwl, inputList = list(), upload = FALSE, ...){
    stopifnot(is(cwl, "cwlProcess"))
    tList <- titlePanel(cwl@id)
    if(length(cwl@label) > 0) tList <- list(tList, h3(cwl@label))
    divList <- .inputUI(cwl, inputList, upload)

    ui <- fluidPage(                
        tList,
        sidebarLayout(
            sidebarPanel(divList),
            mainPanel(
                actionButton("run", "Run"),
                tabsetPanel(
                    tabPanel("Output", verbatimTextOutput("outPath")),
                    tabPanel("Command", verbatimTextOutput("command")),
                    tabPanel("Log", verbatimTextOutput("log"))
                )
            )
        )
    )

    ilist <- inputs(cwl)
    server <- function(input, output){
        res <- eventReactive(input$run, {
            for(x in names(ilist)){
                if(is(ilist[[x]]@type, "InputArrayParam") ||
                   grepl("\\[", ilist[[x]]@type)){
                    v <- unlist(strsplit(input[[x]], split = ","))
                    eval(parse(text=paste0("cwl$",x," <- v")))
                }else{
                    if(ilist[[x]]@type == "File" & upload){
                        eval(parse(text=paste0("cwl$",x," <- input$", x,
                                               "$datapath")))
                    }else{
                        eval(parse(text=paste0("cwl$",x," <- input$", x)))
                    }
                }
            }
            print("Running...")
            runCWL(cwl, ...)
        })
        output$outPath <- renderText({
            paste(res()$output, collapse = "\n")
        })
        output$command <- renderText({
            paste(res()$command, collapse = "\n")
        })
        output$log <- renderText({
            paste(res()$log, collapse = "\n")
        })}

    shinyApp(ui, server)
}

#' @rdname addMeta
#' @return `meta()`: return a list of all available meta information
#'     for the `cwl` object.
#' @export
#' 
meta <- function(cwl){
    idoc <- lapply(cwl@inputs, function(x)list(label = x@label, doc = x@doc))
    odoc <- lapply(cwl@outputs, function(x)list(label = x@label, doc = x@doc))
    if(is(cwl, "cwlWorkflow")){
        sdoc <- lapply(cwl@steps, function(x)list(label = x@label, doc = x@doc))
        metalist <- list(label = cwl@label,
                         doc = cwl@doc,
                         inputs = idoc,
                         outputs = odoc,
                         steps = sdoc,
                         extensions = cwl@extensions)
    }else{
        metalist <- list(label = cwl@label,
                         doc = cwl@doc,
                         inputs = idoc,
                         outputs = odoc,
                         extensions = cwl@extensions)
    }
    return(metalist)
}

#' @rdname addMeta
#' @param value A list of meta information to add to `cwl`.
#' @export
"meta<-" <- function(cwl, value){
    if(!is.null(value$label))
        cwl@label <- value$label    
    if(!is.null(value$doc))
        cwl@doc <- value$doc
    ## if(!is.null(value$extensions))
    ##     cwl@extensions <- value$extensions

    if(length(value$inputs)>0){
        idx <- match(names(value$inputs), names(inputs(cwl)))
        for(i in idx){
            cwl@inputs[[i]]@doc <- value$inputs[[i]]$doc
            cwl@inputs[[i]]@label <- value$inputs[[i]]$label
        }
    }
    if(length(value$outputs) > 0){
        idx <- match(names(value$outputs), names(outputs(cwl)))
        for(i in idx){
            cwl@outputs[[i]]@doc <- value$outputs[[i]]$doc
            cwl@outputs[[i]]@label <- value$outputs[[i]]$label
        }
    }
    if(length(value$steps) > 0){
        idx <- match(names(value$steps), names(steps(cwl)))
        for(i in idx){
            cwl@steps[[i]]@doc <- value$steps[[i]]$doc
            cwl@steps[[i]]@label <- value$steps[[i]]$label
        }
    }

    if(length(value$extensions) > 0){
        ext <- cwl@extensions
        cwl@extensions <- c(ext, value$extensions)
    }

    return(cwl)
}

#' addMeta
#' Add or change meta information for a cwl recipe.
#' @rdname addMeta
#' @aliases addMeta meta
#' @param cwl `cwlProcess` object for data or tool
#'     recipe. `cwlWorkflow` object for a pipeline recipe.
#' @param label Character string specifying a label for the
#'     recipe. E.g., "bwa align", "gencode annotation".
#' @param doc Character string describing the recipe. E.g,
#'     "Align reads to reference genome".
#' @param inputLabels Vector of character string, specifying labels
#'     for each input parameter.
#' @param inputDocs Vector of character string as descriptions for
#'     each input parameter.
#' @param outputLabels Vector of character string, specifying labels
#'     for each output parameter.
#' @param outputDocs Vector of character string as descriptions for
#'     each output parameter.
#' @param stepLabels Vector of character string, specifying labels for
#'     each step. Use only if `cwl` is a `cwlWorkflow` object.
#' @param stepDocs Vector of character string as description for each
#'     step. Use only if `cwl` is a `cwlWorkflow` object.
#' @param extensions A list of character strings. Can be used to add
#'     meta information about the recipe. Generally, add fields of
#'     information that does not require execution as part of the
#'     recipe evaluation. for information about "author", "url",
#'     "date", "example", use the exact names as list names as shown
#'     in examples, so that they can be correctly passed into
#'     corresponding fields in markdown file when using
#'     `meta2md`. Other information can be added as a list element
#'     with arbitrary names. 
#' @return `addMeta()`: `cwlProcess` or `cwlWorkflow` object, with added meta
#'     information, which can be returned using `meta(cwl)`. Meta
#'     information can be converted into markdown file with `meta2md`
#'     function.
#' @examples
#' \dontrun{
#' library(RcwlPipelines)
#' cwlSearch(c("bwa", "align"))
#' bwaAlign <- RcwlPipelines::cwlLoad("pl_bwaAlign")
#' bwaAlign <- addMeta(
#'   cwl = bwaAlign,
#'   label = "align",
#'   doc = "align reads to reference genome",
#'   inputLabels = c("threads", "readgroup", "reference", "read1", "read2"),
#'   inputDocs = c("number of threads", "read groups",
#'                 "reference genome", "read pair1", "read pair2"),
#'   outputLabels = c("Bam", "Idx"),
#'   outputDocs = c("outputbam file", "index file"),
#'   stepLabels = c(bwa = "bwa"),
#'   stepDocs = c(bwa = "bwa alignment"))
#' cat(meta2md(bwaAlign))
#' }
#'
#' \dontrun{
#' rcp <- ReUseData::recipeLoad("gencode_annotation")
#' meta(rcp)
#' rcp1 <- addMeta(
#'   cwl = rcp,
#'   label = "",
#'   doc = "An empty description line", 
#'   inputLabels = c("input label1", "input label2"),
#'   inputDocs = c("input description 1", "input description 2"), 
#'   outputLabels = c("output label1"),
#'   outputDocs = c("output description 1"), 
#'   extensions = list(
#'     author = "recipe author's name",
#'     url = "http://ftp.ebi.ac.uk/pub/databases/gencode/",
#'     date = as.character(Sys.Date()),
#'     example = "An example"))
#' meta(rcp1)
#' cat(meta2md(rcp1))
#' }
#' @export

addMeta <- function(cwl, label = character(), doc = character(),
                    inputLabels = character(),
                    inputDocs = character(),
                    outputLabels = character(),
                    outputDocs = character(),
                    stepLabels = character(),
                    stepDocs = character(),
                    extensions = list()){
    stopifnot(length(inputLabels) == length(inputDocs))
    stopifnot(length(outputLabels) == length(outputDocs))
    stopifnot(length(stepLabels) == length(stepDocs))
    ## inputs
    ilist <- list()
    for(i in seq(inputLabels)){
        ilist[[i]] <- list(label = inputLabels[i], doc = inputDocs[i])
    }

    if(length(inputs(cwl)) > 0){
        if (all(!is.null(names(inputLabels)))){
            names(ilist) <- names(inputLabels)
        }else if (length(inputLabels) == length(inputs(cwl))){
            names(ilist) <- names(inputs(cwl))
        }
    }
    ## outputs
    olist <- list()
    for(i in seq(outputLabels)){
        olist[[i]] <- list(label = outputLabels[i], doc = outputDocs[i])
    }

    if (all(!is.null(names(outputLabels)))){
        names(olist) <- names(outputLabels)
    }else if (length(outputLabels) == length(outputs(cwl))){
        names(olist) <- names(outputs(cwl))
    }
    ## steps
    slist <- list()
    if(is(cwl, "cwlWorkflow")){
        for(i in seq(stepLabels)){
            slist[[i]] <- list(label = stepLabels[i], doc = stepDocs[i])
        }
        
        if (all(!is.null(names(stepLabels)))){
            names(slist) <- names(stepLabels)
        }else if (length(stepLabels) == length(steps(cwl))){
            names(slist) <- names(steps(cwl))
        }
    }
    meta(cwl) <- list(label = label,
                      doc = doc,
                      inputs = ilist,
                      outputs = olist,
                      steps = slist)
    ## extensions = list(`$ext` = extensions))
    if(length(extensions) > 0){
        meta(cwl) <- list(extensions = list(`$ext` = extensions))
    }
    return(cwl)
}

.readInputs <- function(cwl.origin, cwl){
    inputList <- cwl.origin$inputs
    iList <- list()
    for(i in seq_along(inputList)){
        if(cwlClass(cwl) == "Workflow"){
            if(is.character(inputList[[i]])){
                ilist <- list(id = names(inputList)[i], type = inputList[[i]])
            }else{
                ilist <- c(id = names(inputList)[i], inputList[[i]])
            }
        }else{
            ilist <- inputList[[i]]
        }
        if("inputBinding" %in% names(ilist)){
            idx <- match("inputBinding", names(ilist))
            ilist <- c(ilist[-idx], ilist[[idx]])
        }else{
            if(!is(ilist, "list") & is.null(names(ilist))){
                ilist <- list(type = ilist)
            }
            ilist$position = -1
        }
        if(is(ilist$type, "list") &&
           unlist(ilist$type)[["type"]] == "array"){

            if(any(!names(ilist) %in% formalArgs(InputParam))){
                idx <- names(ilist) %in% formalArgs(InputParam)
                warning(names(ilist)[!idx], " not imported")
                ilist <- ilist[idx]
            }
            idx <- names(ilist$type) %in% formalArgs(InputArrayParam)
            ilist$type <- do.call(InputArrayParam, ilist$type[idx])
        }
        if(is.null(ilist$id)){
            ilist$id <- names(inputList)[i]
        }
        iList[[i]] <- do.call(InputParam, ilist)
    }
    names(iList) <- names(inputList)
    return(iList)
}


.readOutputs <- function(cwl.origin, cwl){
    outputList <- cwl.origin$outputs
    oList <- list()
    if(length(outputList) == 0){
        return(oList)
    }
    for(i in seq_along(outputList)){
        if(cwlClass(cwl) == "Workflow"){
            olist <- c(id = names(outputList)[i], outputList[[i]])
        }else if(is(outputList[[i]], "list")){
            olist <- outputList[[i]]
        }else{
            olist <- list(type = outputList[[i]])
        }
        if("outputBinding" %in% names(olist)){
            idx <- match("outputBinding", names(olist))
            olist <- c(olist[-idx], olist[[idx]])
        }
        if(any(!names(olist) %in% formalArgs(OutputParam))){
            idx <- names(olist) %in% formalArgs(OutputParam)
            warning(names(olist)[!idx], " not imported")
            olist <- olist[idx]
        }
        if(is.null(olist$id)){
            olist$id <- names(outputList)[i]
        }
        oList[[i]] <- do.call(OutputParam, olist)
    }
    names(oList) <- names(outputList)
    return(oList)
}

.readSteps <- function(cwl.origin, cwl){
    Steps <- cwl.origin$steps
    for(s in seq_along(Steps)){
        if(is.null(Steps[[s]]$id)){
            id <- names(Steps)[s]
            sList <- c(id = id, Steps[[s]])
        }else{
            sList <- Steps[[s]]
        }
        run <- Steps[[s]]$run
        if(!grepl("^/", run)){
            sList$run <- run #file.path(pwd, run)
        }

        In <- sList$"in"
        slist <- list()
        for(i in seq(In)) {
            if(is.null(names(In)[i])){
                id <- In[[i]]$id
            }else{
                id <- names(In)[i]
            }
            ## if(is.list(In[[i]])) {
            ##     si <- stepInParam(id = id)
            ##     for(j in seq(In[[i]])){
            ##         slot(si, names(In[[i]])[j]) <- In[[i]][[j]]
            ##     }
            ## }else{
            ##     si <- stepInParam(id = id,
            ##                       source = In[[i]])
            ## }
            slist[[i]] <- list(id = id, source = In[[i]])
        }
        names(slist) <- names(In)
        sList$In <- slist # do.call(stepInParamList, slist)
        sList$Out <- as.list(sList$out)
        sList$"in" <- NULL
        sList$"out" <- NULL
        cwl <- cwl + do.call(cwlStep, sList)
    }
    return(cwl)
}

#' Read CWL
#' Function to read CWL command or workflow files.
#' @param cwlfile The cwl file to read.
#' @export
#' @return A object of class `cwlProcess` or `cwlWorkflow`.
#' @examples
#' input1 <- InputParam(id = "sth")
#' echo <- cwlProcess(baseCommand = "echo",
#'                  inputs = InputParamList(input1))
#' tf <- writeCWL(echo)
#' readCWL(tf[1])
readCWL <- function(cwlfile){
    float.handler <- function(x){
        if(x == "."){
            return(".")
        }else{
            return(as.numeric(x))
        }
    }
    handlers <- list("float#fix" = float.handler)
    cwl.origin <- read_yaml(cwlfile, handlers = handlers)
    ## fix listing
    if(("InitialWorkDirRequirement" %in% names(cwl.origin$requirements)) &&
       is(cwl.origin$requirements$InitialWorkDirRequirement$listing, "character")){
        cwl.origin$requirements$InitialWorkDirRequirement$listing <-
            list(cwl.origin$requirements$InitialWorkDirRequirement$listing)
    }

    names(cwl.origin)[names(cwl.origin)=="class"] <- "cwlClass"
    cwl.list1 <- cwl.origin[setdiff(names(cwl.origin),
                                    c("inputs", "outputs", "steps"))]
    idx <- names(cwl.list1) %in% formalArgs(cwlProcess)
    if(cwl.origin$cwlClass %in% c("CommandLineTool", "ExpressionTool")){
        if(!is.null(cwl.list1$arguments)){
            cwl.list1$arguments <- as.list(cwl.list1$arguments)
        }
        cwl <- do.call(cwlProcess, cwl.list1[idx])
    }else if(cwl.origin$cwlClass == "Workflow"){
        cwl <- do.call(cwlWorkflow, cwl.list1[idx])
    }else {
        stop(cwl.origin$cwlClass, "is not supported!")
    }
    cwl@inputs@listData <- .readInputs(cwl.origin, cwl)
    cwl@outputs@listData <- .readOutputs(cwl.origin, cwl)

    if(cwl.origin$cwlClass == "Workflow"){
        ## pwd <- dirname(normalizePath(cwlfile))
        cwl <- .readSteps(cwl.origin, cwl)
    }
    
    if(any(!idx)){
        cwl@extensions <- cwl.list1[!idx]
    }
    return(cwl)
}

setClassUnion("characterORlist", c("character", "list"))

#' All classes defined in the package of `Rcwl` and the class constructor functions.
#' @rdname AllClasses
#' @export
setClass("InputArrayParam",
         slots = c(
             label = "character",
             doc = "character",
             name = "character",
             type = "character",
             items = "characterORlist",
             inputBinding = "list"
         ),
         prototype = list(
             label = character(),
             doc = character(),
             name = character(),
             type = character(),
             items = character(),
             inputBinding = list(prefix = character(),
                                 separate = logical(),
                                 itemSeparator = character(),
                                 valueFrom = character()))
         )

#' @rdname AllClasses
#' @description InputArrayParam: Parameters for array inputs. To
#'     specify an array parameter, the array definition is nested
#'     under the type field with 'type: array' and items defining the
#'     valid data types that may appear in the array. 
#' @param label A short description for the `InputArrayParam` object.
#' @param doc A documentation string for this object.
#' @param name The identifier for this type.
#' @param type Must be "array".
#' @param items Defines the type of the array elements.
#' @param prefix Command line prefix to add before the value.
#' @param separate If true (default), then the prefix and value must
#'     be added as separate command line arguments; if false, prefix
#'     and value must be concatenated into a single command line
#'     argument.
#' @param itemSeparator Join the array elements into a single string
#'     with separator.
#' @param valueFrom String or Expression.
#' @return InputArrayParam: An object of class `InputArrayParam`.
#' @details More details of `InputArrayParam`, see:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#CommandInputArraySchema
#' @export
#' @examples
#' InputArrayParam(items = "string", prefix="-B=", separate = FALSE)
InputArrayParam <- function(label = "", doc = character(), name = character(),
                            type = "array", items = character(), prefix = "",
                            separate = TRUE, itemSeparator = character(),
                            valueFrom = character()){
    new("InputArrayParam",
        label = label,
        doc = doc,
        name = name,
        type = type,
        items = items,
        inputBinding = list(prefix = prefix,
                            separate = separate,
                            itemSeparator = itemSeparator,
                            valueFrom = valueFrom))
}

setClassUnion("characterORInputArrayParamORlist", c("character", "InputArrayParam", "list"))

#' @rdname AllClasses
#' @export
setClass("InputParam",
         slots = c(
             id = "character",
             label = "character",
             doc = "character",
             type = "characterORInputArrayParamORlist",
             secondaryFiles = "characterORlist",
             streamable = "logical",
             format = "character",
             loadContents = "logical",
             loadListing = "character",
             inputBinding = "list",
             default = "ANY",
             value = "ANY"
         ),
         prototype = list(
             id = character(),
             label = character(),
             doc = character(),
             type = character(),
             secondaryFiles = character(),
             streamable = logical(),
             format = character(),
             loadContents = logical(),
             loadListing = character(),
             inputBinding = list(position = integer(),
                                 prefix = character(),
                                 separate = logical(),
                                 itemSeparator = character(),
                                 valueFrom = character(),
                                 shellQuote = logical()),
             default = character(),
             value = character())
         )

#' @rdname AllClasses
#' @description InputParam: parameter for a command line tool.
#' @param id The unique identifier for this parameter object.
#' @param label A short, human-readable label of this object.
#' @param type valid types of data that may be assigned to this
#'     parameter.
#' @param doc Optional. This argument takes an arbitrary documentation
#'     as a note for this object.
#' @param secondaryFiles Only valid when type: File or is an array of
#'     items: File. Provides a pattern or expression specifying files
#'     or directories that must be included alongside the primary
#'     file.
#' @param streamable Only valid when type: File or is an array of
#'     items: File. A value of true indicates that the file is read or
#'     written sequentially without seeking.
#' @param format Only valid when type: File or is an array of items:
#'     File.
#' @param loadContents Only valid when type: File or is an array of
#'     items: File.
#' @param loadListing Only valid when type: Directory or is an array
#'     of items: Directory.
#' @param position The position for this parameter.
#' @param prefix Command line prefix to add before the value.
#' @param separate If true (default), then the prefix and value must
#'     be added as separate command line arguments; if false, prefix
#'     and value must be concatenated into a single command line
#'     argument.
#' @param itemSeparator Join the array elements into a single string
#'     with the elements separated by by itemSeparator.
#' @param valueFrom String or Expression.
#' @param shellQuote If ShellCommandRequirement is in the requirements
#'     for the current command, this controls whether the value is
#'     quoted on the command line (default is true).
#' @param default The default value for this parameter
#' @param value Assigned value for this parameter
#' @return An object of class `InputParam`.
#' @details More details for `InputParam`, see:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#CommandInputParameter
#' @export
#' @examples
#' input1 <- InputParam(id = "sth")
#' InputParamList(input1)
InputParam <- function(id, label= "", type = "string",
                       doc = character(), secondaryFiles = character(),
                       streamable = logical(), format = character(),
                       loadListing = character(),
                       loadContents = logical(), position = 0L, prefix = "",
                       separate = TRUE, itemSeparator = character(),
                       valueFrom = character(), shellQuote = logical(),
                       default = character(), value = character()){
    ## init value by type
    if(is(type, "InputArrayParam")){
        value <- list()
    }else{
        if(!is.na(pmatch("int", type))){
            value <- integer()
        }else if(!is.na(pmatch("boolean", type))){
            value <- logical()
        }else if(!is.na(pmatch("float", type))){
            value <- numeric()
        }else if(!is.na(pmatch("int", type))){
            value <- numeric()
        }else if(any(grepl("\\[\\]", type))){
            value <- list()
        }else{
            value <- character()
        }
    }
    new("InputParam",
        id = id,
        label = label,
        doc = doc,
        type = type,
        secondaryFiles = secondaryFiles,
        streamable = streamable,
        format = format,
        loadContents = loadContents,
        loadListing = loadListing,
        inputBinding = list(position = as.integer(position),
                            prefix = prefix,
                            separate = separate,
                            itemSeparator = itemSeparator,
                            valueFrom = valueFrom,
                            shellQuote = shellQuote),
        default = default,
        value = value)
}

setMethod(show, "InputParam", function(object){
    cat(as.yaml(as.listInputs(list(object))))
})

#' @rdname AllClasses
#' @export
setClass("InputParamList",
         ## representation(inputs = "SimpleList"),
         prototype = list(elementType = "InputParam"),
         contains = "SimpleList")

#' @rdname AllClasses
#' @description InputParamList: A list of `InputParam` objects.
#' @param ... The `InputParam` objects.
#' @return InputParamList: An object of class `InputParamList`.
#' @export

InputParamList <- function(...){
    iList <- list(...)
    names(iList) <- lapply(iList, function(x)x@id)
    ## new("InputParamList", inputs = iList)
    new("InputParamList", listData = iList)
}

setMethod(show, "InputParamList", function(object) {
    cat("inputs:\n")
    lapply(seq(object), function(i){
        if(object[[i]]@label != ""){
            iname <- paste0(names(object)[i], " (", object[[i]]@label, ") ")
        }else{
            iname <- names(object)[i]
        }
        if(is(object[[i]]@type, "character")){
            if(length(object[[i]]@value) > 0){
                v <- object[[i]]@value
            }else{
                v <- object[[i]]@default
            }
            if(object[[i]]@type %in% c("File", "Directory")){
                if(length(object[[i]]@value) > 0){
                    v <- object[[i]]@value$path
                }else{
                    v <- object[[i]]@value
                }
            }

            cat("  ", iname, " (", object[[i]]@type, "): ",
                object[[i]]@inputBinding$prefix, " ",
                paste(unlist(v), collapse = " "), "\n", sep = "")
        }else if(is(object[[i]]@type, "InputArrayParam")){
            if(any(object[[i]]@type@items %in% c("File", "Directory"))){
                if(length(object[[i]]@value) > 0){
                    v <- object[[i]]@value$path
                }else{
                    v <- object[[i]]@value
                }
            }else{
                v <- object[[i]]@value
            }
            cat("  ", iname, ":\n", sep = "")
            cat("    type: ", object[[i]]@type@type, "\n", sep = "")
            cat("    prefix: ",
                object[[i]]@type@inputBinding$prefix, " ",
                paste(unlist(v), collapse=" "), "\n", sep = "")
        }else if(is(object[[i]]@type, "list")){
            cat(" ", iname, " (", paste0(unlist(object[[i]]@type),
                                          collapse = "|"), "): \n")
        }
    })
})

setClassUnion("InputParamListORlist", c("InputParamList", "list"))
setMethod(show, "InputParamListORlist", function(object) {
    if(!length(object)) {
        cat("input:\n")
        cat(as.yaml(object))
    } else {
        object
    }
})

#' @rdname AllClasses
#' @export
setClass("OutputArrayParam",
         slots = c(
             label = "character",
             doc = "character",
             name = "character",
             type = "character",
             items = "characterORlist"
         ),
         prototype = list(
             label = character(),
             doc = character(),
             name = character(),
             type = character(),
             items = character())
         )

#' @rdname AllClasses
#' @description OutputArrayParam: Parameters for array outputs.
#' @param label A short, human-readable label of this object.
#' @param type Must be "array".
#' @param doc A documentation string for this object.
#' @param name The identifier for this type.
#' @param items Defines the type of the array elements.
#' @param glob Pattern to find files relative to the output directory.
#' @param loadContents Read text from globbed file.
#' @param outputEval Evaluate an expression to generate the output
#'     value.
#' @details More details for `OutputArrayParam`, see:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#CommandOutputArraySchema
#' @return An object of class `OutputArrayParam`.
#' @export
#' @examples
#' OutputParam(id = "b", type = OutputArrayParam(items = "File"), glob = "*.txt")
OutputArrayParam <- function(label= character(), doc = character(),
                             name = character(), type = "array",
                             items = character()){
    new("OutputArrayParam",
        label = label,
        doc = doc,
        name = name,
        type = type,
        items = items)
}

setClassUnion("characterOROutputArrayParamORlist", c("character", "OutputArrayParam", "list"))

#' @rdname AllClasses
#' @export
setClass("OutputParam",
         slots = c(
             id = "character",
             label = "character",
             doc = "character",
             format = "character",
             type = "characterOROutputArrayParamORlist",
             secondaryFiles = "characterORlist",
             streamable = "logical",
             outputBinding = "list",
             outputSource = "character",
             linkMerge = "character",
             pickValue = "character"
         ),
         prototype = list(id = character(),
                          label = character(),
                          doc = character(),
                          format = character(),
                          type = character(),
                          secondaryFiles = character(),
                          streamable = logical(),
                          outputBinding = list(glob = character(),
                                               loadContents = logical(),
                                               loadListing = character(),
                                               outputEval = character()),
                          outputSource = character(),
                          linkMerge = character(),
                          pickValue = character())
         )

#' @rdname AllClasses
#' @description OutputParam: An output parameter for a Command Line
#'     Tool.
#' @param id The unique identifier for this parameter object.
#' @param label A short, human-readable label of this object.
#' @param doc A documentation string for this object, or an array of
#'     strings which should be concatenated.
#' @param format Only valid when type: File or is an array of items:
#'     File. This is the file format that will be assigned to the
#'     output File object.
#' @param type Specify valid types of data that may be assigned to
#'     this parameter.
#' @param secondaryFiles Provides a pattern or expression specifying
#'     files or directories. Only valid when type: File or is an array
#'     of items: File.
#' @param streamable A value of true indicates that the file is read
#'     or written sequentially without seeking. Only valid when type:
#'     File or is an array of items: File.
#' @param glob Pattern to find files relative to the output directory.
#' @param loadContents Read text from globbed file.
#' @param outputEval Evaluate an expression to generate the output
#'     value.
#' @param outputSource Specifies one or more workflow parameters that
#'     supply the value of to the output parameter.
#' @param linkMerge The method to use to merge multiple sources into a
#'     single array. If not specified, the default method is
#'     "merge_nested".
#' @param pickValue The method to use to choose non-null elements
#'     among multiple sources.
#' @details More details for `OutputParam`, see:
#'     https://www.commonwl.org/v1.0/CommandLineTool.html#CommandOutputParameter
#' @return OutputParam: An object of class `OutputParam`.
#' @export
#' @examples
#' o1 <- OutputParam(id = "file", type = "File", glob = "*.txt")
#' o1
#' 
OutputParam <- function(id = "output", label = character(), doc = character(),
                        type = "stdout",  format = character(),
                        secondaryFiles = character(), streamable = logical(),
                        glob = character(), loadContents = logical(),
                        loadListing = character(), outputEval = character(),
                        outputSource = character(),
                        linkMerge = character(),
                        pickValue = character()){
    new("OutputParam",
        id = id,
        label = label,
        doc = doc,
        type = type,
        format = format,
        secondaryFiles = secondaryFiles,
        streamable = streamable,
        outputBinding = list(glob = glob,
                             loadContents = loadContents,
                             loadListing = loadListing,
                             outputEval = outputEval),
        outputSource = outputSource,
        linkMerge = linkMerge,
        pickValue = pickValue)
}

setMethod(show, "OutputParam", function(object){
    cat(as.yaml(as.listOutputs(list(object))))
})

#' @rdname AllClasses
#' @export
setClass("OutputParamList",
         ## representation(outputs = "SimpleList"),
         prototype = list(elementType = "OutputParam"),
         contains = "SimpleList")

#' @rdname AllClasses
#' @description OutputParamList: A list of `InputParam` objects.
#' @param out The default stdout parameter.
#' @param ... The `OutputParam` objects.
#' @return OutputParamList: An object of class `OutputParamList`.
#' @export
#' @examples
#' o1 <- OutputParam(id = "file", type = "File", glob = "*.txt")
#' OutputParamList(o1)
OutputParamList <- function(out = OutputParam(), ...){
    oList <- list(out, ...)
    names(oList) <- lapply(oList, function(x)x@id)
    new("OutputParamList", listData = oList)
}

setMethod(show, "OutputParamList", function(object) {
    cat("outputs:\n")
    cat(as.yaml(as.listOutputs(object)))
})

setClassUnion("OutputParamListORlist", c("OutputParamList", "list"))
setClassUnion("characterORlistORfunction", c("character", "list", "function"))

#' @rdname AllClasses
#' @export
setClass("cwlProcess",
         slots = c(
             cwlVersion = "character",
             cwlClass = "character",
             baseCommand = "characterORlistORfunction",
             requirements = "list",
             hints = "list",
             arguments = "list",
             id = "character",
             label = "character",
             doc = "characterORlist",
             inputs = "InputParamListORlist",
             outputs = "OutputParamListORlist",
             stdout = "character",
             stderr = "character",
             stdin = "character",
             expression = "character",
             extensions = "list",
             intent = "list"
         ),
         prototype = list(cwlVersion = character(),
                          cwlClass = character(),
                          baseCommand = character(),
                          requirements = list(),
                          hints = list(),
                          id = character(),
                          label = character(),
                          doc = character(),
                          arguments = list(),
                          inputs = InputParamList(),
                          outputs = OutputParamList(),
                          stdout = character(),
                          stderr = character(),
                          stdin = character(),
                          expression = character(),
                          extensions = list(),
                          intent = list()
         ))

setMethod(show, "cwlProcess", function(object){
    if(is(baseCommand(object), "function")){
        bc <- c("baseCommand: R function", "\n")
    }else{
        bc <- c("baseCommand:", unlist(baseCommand(object)), "\n")
    }
    cat("class:", class(object), "\n",
        "cwlClass:", cwlClass(object), "\n",
        "cwlVersion:", cwlVersion(object), "\n",
        bc)
    if(length(object@requirements) > 0){
        cat("requirements:\n")
        cat(as.yaml(object@requirements))
    }
    if(length(object@hints) > 0){
        cat("hints:\n")
        cat(as.yaml(object@hints))
    }
    if(length(object@arguments) > 0){
        cat("arguments:", unlist(object@arguments), "\n")
    }
    show(object@inputs)
    show(object@outputs)
    if(length(object@stdin) > 0) cat("stdin:", object@stdin, "\n")
    if(length(object@stdout) > 0) cat("stdout:", object@stdout, "\n")
    if(length(object@stderr) > 0) cat("stderr:", object@stderr, "\n")
})

#' @rdname AllClasses
#' @export
setClass("stepInParam",
         slots = c(id = "character",
                   source = "characterORlist",
                   linkMerge = "character",
                   pickValue = "character",
                   loadContents = "logical",
                   loadListing = "character",
                   label = "character",
                   default = "ANY",
                   valueFrom = "character"))

#' @rdname AllClasses
#' @description stepInParam: The input parameter of a workflow step.
#' @param id A unique identifier for this workflow input parameter.
#' @param source Specifies one or more workflow parameters that will
#'     provide input to the underlying step parameter.
#' @param linkMerge The method to use to merge multiple inbound links
#'     into a single array.
#' @param pickValue The method to use to choose non-null elements
#'     among multiple sources. "first_non_null", "the_only_non_null",
#'     or "all_non_null".
#' @param loadContents Only valid when type: File or is an array of
#'     items: File.
#' @param loadListing Only valid when type: Directory or is an array
#'     of items: Directory. "no_listing", "shallow_listing" or
#'     "deep_listing".
#' @param default The default value for this parameter to use if
#'     either there is no source field, or the value produced by the
#'     source is null.
#' @param valueFrom value from string or expression.
#' @details More details for `stepInParam`, see:
#'     https://www.commonwl.org/v1.0/Workflow.html#WorkflowStepInput
#' @return stepInParam: An object of class `stepInParam`.
#' @export
#' @examples
#' s1 <- stepInParam(id = "s1")
#' 
stepInParam <- function(id, source = character(),
                        linkMerge = character(),
                        pickValue = character(),
                        loadContents = logical(),
                        loadListing = character(),
                        default = character(),
                        valueFrom = character()){
    new("stepInParam",
        id = id, source = source, linkMerge = linkMerge,
        pickValue = pickValue,
        loadContents = loadContents,
        loadListing = loadListing,
        default = default, valueFrom = valueFrom)
}

#' @rdname AllClasses
#' @export
setClass("stepInParamList",
         ## representation(Ins = "SimpleList"),
         prototype = list(elementType = "stepInParam"),
         contains = "SimpleList")

#' @rdname AllClasses
#' @description stepInParamList: A list of `stepInParam` objects.
#' @param ... A list of `stepInParam` objects.
#' @return An object of class `stepInParamList`.
#' @export
#' @examples
#' s1 <- stepInParam(id = "s1")
#' stepInParamList(s1)
stepInParamList <- function(...){
    iList <- list(...)
    ## stopifnot(all(vapply(iList, is, character(1)) == "stepInParam"))
    names(iList) <- lapply(iList, function(x)x@id)
    new("stepInParamList", listData = iList)
}

setClassUnion("cwlProcessORcharacter", c("cwlProcess", "character"))

#' @rdname AllClasses
#' @export
setClass("cwlStep",
         slots = c(id = "character",
                   run = "cwlProcessORcharacter",
                   In = "stepInParamList",
                   Out = "list",
                   scatter = "characterORlist",
                   scatterMethod = "character",
                   label = "character",
                   doc = "character",
                   requirements = "list",
                   hints = "list",
                   when = "character"))

# show methods for cwlStep
setMethod(show, "cwlStep", function(object) {
    cat(as.yaml(as.listSteps(list(object))))
    ## cat("  ", object@id, ":\n", sep = "")
    ## cat("    run: ", paste0(object@id, ".cwl"), "\n", sep = "")
    ## lapply(object@In, function(y) {
    ##     cat("    ", paste0(y@id, ": ", y@source), "\n", sep = "")
    ## })
    ## cat("    out: ", paste(unlist(object@Out), collapse=" "), "\n", sep = "")
    ## if(length(object@scatter) > 0){
    ##     cat("    scatter:", unlist(object@scatter), "\n", sep = " ")
    ##     if(length(object@scatterMethod) > 0){
    ##         cat("    scatterMethod: ", object@scatterMethod, "\n", sep = "")
    ##     }
    ## }
})

#' @rdname AllClasses
#' @export
setClass("cwlStepList",
         ## representation(steps = "SimpleList"),
         prototype = list(elementType = "cwlStep"),
         contains = "SimpleList")

#' @rdname AllClasses
#' @description cwlStepList: A list of `cwlStep` objects.
#' @param ... A list of `cwlStep` objects.
#' @return cwlStepList: An object of class `cwlStepList`.
#' @export
#' @examples
#' s1 <- cwlStep(id = "s1")
#' cwlStepList(s1)
cwlStepList <- function(...){
    iList <- list(...)
    names(iList) <- lapply(iList, function(x)x@id)
    new("cwlStepList", listData = iList)
}

setMethod(show, "cwlStepList", function(object) {
    cat("steps:\n")
    cat(as.yaml(as.listSteps(object)))
    ## lapply(object, function(x) {
    ##     show(x)
    ## })
})

#' @rdname AllClasses
#' @export
setClass("cwlWorkflow",
         contains = "cwlProcess",
         slots = c(steps = "cwlStepList"),
         prototype = list(steps = cwlStepList())
         )

setMethod(show, "cwlWorkflow", function(object){
    cat("class:", class(object), "\n",
        "cwlClass:", cwlClass(object), "\n",
        "cwlVersion:", cwlVersion(object), "\n")
    if(length(object@requirements) > 0){
        cat("requirements:\n")
        cat(as.yaml(object@requirements))
    }
    if(length(object@hints) > 0){
        cat("hints:\n")
        cat(as.yaml(object@hints))
    }
    if(length(object@arguments) > 0){
        cat("arguments:", unlist(object@arguments), "\n")
    }
    show(object@inputs)
    show(object@outputs)
    if(length(object@stdout) > 0) cat("stdout:", object@stdout, "\n")
    if(cwlClass(object) == "Workflow") {
        show(object@steps)
    }
})

## test echo
input1 <- InputParam(id = "sth")
echo <- cwlProcess(baseCommand = "echo", inputs = InputParamList(input1))
echo$sth <- "Hello World!"
install_cwltool()
r1 <- runCWL(echo)
test_that("simple echo", {
    expect_match(tail(r1$logs, 1), "success")})

out1 <- readLines(r1$output)
test_that("simple echo", {
    expect_equal(out1, "Hello World!")})

## no inputBinding
p1 <- InputParam(id = "infiles", type = "File[]")
p2 <- InputParam(id = "outfile", type = "string",
                 default = "catout.txt", position = -1)
Cat <- cwlProcess(baseCommand = "cat",
                inputs = InputParamList(p1, p2),
                stdout = "$(inputs.outfile)")
writeCWL(Cat, prefix = "cat", outdir = tempdir())
Cat1 <- readCWL(file.path(tempdir(), "cat.cwl"))
test_that("negative position", {
    expect_equal(inputs(Cat1)$outfile@inputBinding$position, -1)})

## InputParam
test_that("InputParam class", {
    expect_error(InputParam())
})

test_that("InputParamList class and element type", {
    expect_true(is(echo@inputs, "SimpleList"))
    expect_true(is(echo@inputs, "InputParamList"))
    expect_true(validObject(InputParamList()))
    expect_error(InputParamList(p1, p2, "test"))
    expect_error(InputParamList(p1, p2, OuputParam(id = "test")))
})

## OutputParam
o1 <- OutputParam(id = "file", type = "File", glob = "*.txt")
test_that("InputParam class", {
    expect_true(validObject(OutputParam()))
})

test_that("OutputParamList class and element type", {
    expect_true(is(echo@outputs, "SimpleList"))
    expect_true(is(echo@outputs, "OutputParamList"))
    expect_true(validObject(OutputParamList()))
    expect_error(OutputParamList(o1, "test"))
    expect_error(OutputParamList(o1, InputParam(id = "test")))
})

## ## ExpressionTool, not pass check in bioc server
## p1 <- InputParam(id = "file1", type = "File")
## p2 <- InputParam(id = "file2", type = "File")
## o1 <- OutputParam(id = "out", type = "Directory")
## expression <- '${
##     return {"out": {
##         "class": "Directory",
##         "basename": "group",
##         "listing": [inputs.file1, inputs.file2]
##     }};
## }'
## req <- list(class = "InlineJavascriptRequirement")
## groupFiles <- cwlProcess(cwlClass = "ExpressionTool",
##                        requirements = list(req),
##                        inputs = InputParamList(p1, p2),
##                        outputs = OutputParamList(o1),
##                        expression = expression)
## f1 <- tempfile()
## f2 <- tempfile()
## file.create(f1, f2)
## groupFiles$file1 <- f1
## groupFiles$file2 <- f2
## r1 <- runCWL(groupFiles, outdir = tempdir())
## test_that("ExpressionTool", {
##     expect_true(all(basename(r1$output) %in%
##                     c("group", basename(f1), basename(f2))))
## })

## extensions and metadata
test_that("extensions", {
    ext <- list("$namespaces" = list(
                    s = "https://schema.org/"),
                "s:author" = list(
                    class = "s:Person",
                    "s:name" = "Qiang H"
                ))
    extensions(echo) <- ext
    r1 <- runCWL(echo)
    writeCWL(echo, prefix = "echo", outdir = tempdir())
    cwlfile <- file.path(tempdir(), "echo.cwl")
    
    expect_match(tail(r1$logs, 1), "success")
    expect_true(all(ext %in% read_yaml(cwlfile)))
})

## test R function
fun1 <- function(x)x*2
testFun <- function(a, b){
    cat(fun1(a) + b^2, sep="\n")
}
assign("fun1", fun1, envir = .GlobalEnv)
assign("testFun", testFun, envir = .GlobalEnv)
p1 <- InputParam(id = "a", type = "int", prefix = "a=", separate = F)
p2 <- InputParam(id = "b", type = "int", prefix = "b=", separate = F)
o1 <- OutputParam(id = "o", type = "File", glob = "rout.txt")
TestFun <- cwlProcess(baseCommand = testFun,
                      inputs = InputParamList(p1, p2),
                      outputs = OutputParamList(o1),
                      stdout = "rout.txt")
TestFun$a <- 1
TestFun$b <- 2
res <- runCWL(TestFun, outdir = tempdir())
## test_that("R function", {
##     ## test failed in bioc macos
##     ## expect_equal(readLines(res$output), "6")
## })

#' Rcwl-package
#'
#' An R package to wrap command line tools and build pipelines with
#' Common Workflow Language (CWL).
#' _PACKAGE
#' @name Rcwl-package
#' @rdname Rcwl-package
#' @aliases Rcwl Rcwl,Rcwl-package
#' @seealso \code{\link{cwlProcess}}
#' @seealso \code{\link{cwlWorkflow}}
#' @seealso \code{\link{cwlStep}} 
#' @seealso \code{\link{runCWL}}
NULL

#' cwlProcess methods
#' @name cwlProcess-methods
#' @rdname cwlProcess-methods
#' @description Some useful methods for `cwlProcess` objects.
#' @param cwl A `cwlProcess` (or `cwlWorkflow`) object.
#' @param value A value to be assigned to the `cwlProcess` object.
#' @return cwlVersion: cwl document version
#' @export
#' @examples
#' ip <- InputParam(id = "sth")
#' echo <- cwlProcess(baseCommand = "echo", inputs = InputParamList(ip))
#' cwlVersion(echo)
#' cwlClass(echo)
#' baseCommand(echo)
#' hints(echo)
#' requirements(echo)
#' inputs(echo)
#' outputs(echo)
#' stdOut(echo)
#' extensions(echo)
#' 
#' s1 <- cwlWorkflow()
#' runs(s1)
#' s1
#' short(s1)
 
cwlVersion <- function(cwl) cwl@cwlVersion

#' @rdname cwlProcess-methods
#' @export
"cwlVersion<-" <- function(cwl, value){
    cwl@cwlVersion  <- value
    cwl
}

#' @rdname cwlProcess-methods
#' @return cwlClass: CWL class of `cwlProcess` or `cwlWorkflow` object.
#' @export
cwlClass <- function(cwl) cwl@cwlClass

#' @rdname cwlProcess-methods
#' @export
"cwlClass<-" <- function(cwl, value){
    cwl@cwlClass <- value
    cwl
}

#' @rdname cwlProcess-methods
#' @return baseCommand: base command for the `cwlProcess` object.
#' @export
baseCommand <- function(cwl) cwl@baseCommand

#' @rdname cwlProcess-methods
#' @export
"baseCommand<-" <- function(cwl, value){
    cwl@baseCommand <- value
    cwl
}

#' @rdname cwlProcess-methods
#' @param step the ID of steps in a workflow. This is required if
#'     "cwl" is a `cwlWorkflow` object. It can be multiple levels of
#'     steps separated by "/" for nested workflow.
#' @return arguments: CWL arguments.
#' @export

arguments <- function(cwl, step = NULL){
    if(cwlClass(cwl) == "CommandLineTool"){
        cwl@arguments        
    }else if(cwlClass(cwl) == "Workflow"){
        ## allRun(cwl)[[step]]@arguments
        stopifnot(!is.null(step))
        Steps <- unlist(strsplit(step, split = "/"))
        irun <- "cwl@steps[[ Steps[1] ]]@run"
        if(length(Steps) > 1){
            for(i in 2:length(Steps)){
                irun <- paste0(irun, "@steps[[ Steps[", i, "] ]]@run")
            }
        }
        irun <- paste0(irun, "@arguments")
        eval(parse(text = irun))
    }
}

#' @rdname cwlProcess-methods
#' @export
"arguments<-" <- function(cwl, step = NULL, value){
    if(cwlClass(cwl) == "CommandLineTool"){
        cwl@arguments <- value
    }else if(cwlClass(cwl) == "Workflow"){
        stopifnot(!is.null(step))
        Steps <- unlist(strsplit(step, split = "/"))
        irun <- "cwl@steps[[ Steps[1] ]]@run"
        if(length(Steps) > 1){
            for(i in 2:length(Steps)){
                irun <- paste0(irun, "@steps[[ Steps[", i, "] ]]@run")
            }
        }
        valuec <- as.character(value)
        idxl <- !grepl("^list", valuec)
        if(sum(idxl) > 0){
            valuec[idxl] <- paste0("\"", valuec[idxl], "\"")
        }
        value <- paste(valuec, collapse = ",")
        irun <- paste0(irun, "@arguments <- list(", value, ")")
        eval(parse(text = irun))
    }
    cwl
}

#' @rdname cwlProcess-methods
#' @return hints: CWL hints.
#' @export
hints <- function(cwl) cwl@hints

#' @rdname cwlProcess-methods
#' @export
"hints<-" <- function(cwl, value){
    cwl@hints <- value
    cwl
}

#' @rdname cwlProcess-methods
#' @return requirements: CWL requirments.
#' @export
requirements <- function(cwl, step = NULL){
    if(is.null(step)){
        return(cwl@requirements)
    }else{
        Steps <- unlist(strsplit(step, split = "/"))
        irun <- "cwl@steps[[ Steps[1] ]]@run"
        if(length(Steps) > 1){
            for(i in 2:length(Steps)){
                irun <- paste0(irun, "@steps[[ Steps[", i, "] ]]@run")
            }
        }
        irun <- paste0(irun, "@requirements")
        eval(parse(text = irun))
    }
}

#' @rdname cwlProcess-methods
#' @param step To specifiy a step ID when `cwl` is a workflow.
#' @param value To assign a list of `requirements` value.
#' @export
## "requirements<-" <- function(cwl, value){
##     cwl@requirements <- value
##     cwl
## }
"requirements<-" <- function(cwl, step = NULL, value){
    if(is.null(step)){
        cwl@requirements <- value
    }else{
        Steps <- unlist(strsplit(step, split = "/"))
        irun <- "cwl@steps[[ Steps[1] ]]@run"
        if(length(Steps) > 1){
            for(i in 2:length(Steps)){
                irun <- paste0(irun, "@steps[[ Steps[", i, "] ]]@run")
            }
        }
        valuec <- as.character(value)
        idxl <- !grepl("^list", valuec)
        if(sum(idxl) > 0){
            valuec[idxl] <- paste0("\"", valuec[idxl], "\"")
        }
        value <- paste(valuec, collapse = ",")
        irun <- paste0(irun, "@requirements <- list(", value, ")")
        eval(parse(text = irun))
    }
    cwl
}

#' @rdname cwlProcess-methods
#' @return inputs: A list of `InputParam`.
#' @export

inputs <- function(cwl) cwl@inputs

.assignInput <- function(x, name, value){
    if(!name %in% names(inputs(x)))
        stop(name, " is not in the inputs")
    itype <- inputs(x)[[name]]@type
    if(is(itype, "InputArrayParam")){
        if(inputs(x)[[name]]@type@items == "File"){
            v <- lapply(value, function(x)list(class="File",
                                               path=normalizePath(x)))
        }else if(inputs(x)[[name]]@type@items == "Directory"){
            v <- lapply(value, function(x)list(class="File",
                                               path=normalizePath(x)))
        }else{
            v <- value
        }
    }else if(is(itype, "character")){
        ## optional type
        if(grepl("?", itype)){
            itype <- sub("\\?", "", itype)
        }
        if(itype == "int"){
            v <- as.integer(value)
        }else if(itype %in% c("File", "Directory")){
            if(length(value) == 0 || value == "")
                stop(name, " is empty!")
            if(!file.exists(value))
                stop(value, " does not exist!")
            v <- list(class = itype, path = normalizePath(value))
        }else if(itype == "File[]"){
            v <- lapply(value, function(x)list(class="File",
                                               path=normalizePath(x)))
        }else if(itype == "Directory[]"){
            v <- lapply(value, function(x)list(class="Directory",
                                               path=normalizePath(x)))
        }else{
            v <- value
        }
    }else if(is(itype, "list")){
        if(is(value, "list")){
            if(file_test("-d", value[[1]])){
                v <- lapply(value, function(x)list(class="Directory",
                                                   path=normalizePath(x)))
            }else if(file_test("-f", value[[1]])){
                v <- lapply(value, function(x)list(class="File",
                                                   path=normalizePath(x)))
            }else{
                v <- value
            }
        }else{
            if(file_test("-d", value)) {
                v <- list(class = "Directory", path = normalizePath(value))
            }else if(file_test("-f", value)){
                v <- list(class = "File", path = normalizePath(value))
            }else{
                v <- value
            }
        }
    }
    x@inputs[[name]]@value <- v
    x
}

#' @importFrom utils .DollarNames
.DollarNames.cwlProcess <- function(x, pattern = "") {
    grep(pattern, names(inputs(x)), value = TRUE)
}

#' @rdname cwlProcess-methods
#' @description `$`: Extract input values for `cwlProcess`
#'     object. (Can auto-complete the input names using tab)
#' @return `$`: the `InputParam` value for `cwlProcess` object. 
#' @importFrom S4Vectors wmsg
#' @export
#' 
setMethod("$", "cwlProcess", function(x, name){
    if(name %in% names(inputs(x))){
        inputs(x)[[name]]@value
    }else{
        stop(wmsg("the '", name, "' does not exist"))
    }
})

#' @rdname cwlProcess-methods
#' @description `$<-`: Set input values for `cwlProcess` object by name.
#' @param x A `cwlProcess` object.
#' @param name One of input list.
#' @export

setReplaceMethod("$", "cwlProcess", function(x, name, value){
    .assignInput(x, name, value)
})

setGeneric("$")

#' @rdname cwlProcess-methods
#' @description outputs: The outputs of a `cwlProcess` object.
#' @export
#' @return outputs: A list of `OutputParam`.

outputs <- function(cwl) {
    cwl@outputs
}

#' @rdname cwlProcess-methods
#' @description stdOut: stdout of `cwlProcess` object.
#' @return stdOut: CWL stdout.
#' @export
stdOut <- function(cwl) cwl@stdout

#' @rdname cwlProcess-methods
#' @export
"stdOut<-" <- function(cwl, value){
    cwl@stdout <- value
    cwl
}

#' @rdname cwlProcess-methods
#' @description extensions: Extensions and metadata of `cwlProcess` object.
#' @return extensions: A list of extensions or metadata.
#' @export
extensions <- function(cwl) cwl@extensions

#' @rdname cwlProcess-methods
#' @export
"extensions<-" <- function(cwl, value){
    cwl@extensions <- value
    cwl
}

#' @rdname cwlProcess-methods
#' @description short: The function to show a short summary of `cwlProcess` or
#' `cwlWorkflow` object.
#' @return short: A short summary of an object of `cwlProcess` or `cwlWorkflow`.
#' @export

short <- function(cwl){
    if(is(cwl, "cwlProcess")){
        cat(as.yaml(list(inputs = names(inputs(cwl)))))
        cat(as.yaml(list(outputs = names(outputs(cwl)))))
    }
    if(is(cwl, "cwlWorkflow")) {
        cat(as.yaml(list(steps = names(steps(cwl)))))
    }
}

#' cwlWorkflow methods
#' @name cwlWorkflow-methods
#' @rdname cwlWorkflow-methods
#' @description runs: The function to access all runs of a `cwlWorkflow` object.
#' @param object A `cwlWorkflow` object.
#' @return `cwlProcess` objects or paths of CWL file.
#' @export
#' @examples
#' s1 <- cwlWorkflow()
#' runs(s1)
#' s1
#' short(s1)

runs <- function(object){
    stopifnot(is(object, "cwlWorkflow"))
    SimpleList(lapply(steps(object), function(x)x@run))
}

#' cwlWorkflow function
#'
#' @description The constructor function for `cwlWorkflow` object,
#'     which connects multiple command line steps into a workflow.
#' @param cwlVersion CWL version
#' @param cwlClass "Workflow".
#' @param requirements Requirements that apply to either the runtime
#'     environment or the workflow engine.
#' @param hints Any or a list for the workflow engine.
#' @param extensions A list of extensions and metadata.
#' @param arguments Command line bindings which are not directly
#'     associated with input parameters.
#' @param id A user-defined unique identifier for this workflow.
#' @param label A short, human-readable label of this object.
#' @param doc A documentation string for this object.
#' @param inputs An object of `InputParamList`.
#' @param outputs An object of `OutputParamList`.
#' @param steps A list of `cwlStepList`.
#' @param intent An identifier for the type of computational
#'     operation, of this Process.
#' @export
#' @return cwlWorkflow: An object of class `cwlWorkflow`.
#' @seealso \code{\link{stepInParamList}}
#' @examples
#' input1 <- InputParam(id = "sth")
#' echo1 <- cwlProcess(baseCommand = "echo",
#'                   inputs = InputParamList(input1))
#' input2 <- InputParam(id = "sthout", type = "File")
#' echo2 <- cwlProcess(baseCommand = "echo",
#'                   inputs = InputParamList(input2),
#'                   stdout = "out.txt")
#' i1 <- InputParam(id = "sth")
#' o1 <- OutputParam(id = "out", type = "File", outputSource = "echo2/output")
#' wf <- cwlWorkflow(inputs = InputParamList(i1),
#'                    outputs = OutputParamList(o1))
#' s1 <- cwlStep(id = "echo1", run = echo1, In = list(sth = "sth"))
#' s2 <- cwlStep(id = "echo2", run = echo2, In = list(sthout = "echo1/output"))
#' wf <- wf + s1 + s2
cwlWorkflow <- function(cwlVersion = "v1.0", cwlClass = "Workflow",
                         requirements = list(), id = character(),
                         label = character(), doc = character(), intent = list(),
                         hints = list(), arguments = list(), extensions = list(),
                         inputs = InputParamList(), outputs = OutputParamList(),
                         steps = cwlStepList()){
    new("cwlWorkflow", cwlVersion = cwlVersion, cwlClass = cwlClass,
        requirements = requirements, id = id, label = label,
        doc = doc, intent = intent, hints = hints,
        arguments = arguments, inputs = inputs, outputs = outputs,
        steps = steps, extensions = extensions)
}

#' @rdname cwlWorkflow
#' @param e1 A `cwlWorkflow` object.
#' @param e2 A `cwlStep` object.
#' @export

## setMethod("+", c("cwlWorkflow", "cwlStep"), function(e1, e2) {
##     ##if (length(e1@steps) == 0) {
##     ##    e1@steps <- cwlStepList(e2)
##     ##} else {
##     e1@steps <- do.call(cwlStepList, c(e1@steps@listData, e2))
##     ##}
##     return(e1)
## })

setMethod("+", c("cwlWorkflow", "cwlStep"), function(e1, e2) {
    ## whether outputs were already defined
    if(length(steps(e1))==0){
        if(length(e1@outputs) == 0){
            attr(e1, "_outs") <- FALSE
        }else if(length(e1@outputs) == 1 && e1@outputs[[1]]@type == "stdout"){
            attr(e1, "_outs") <- FALSE
        }else{
            ##if(length(e1@outputs)>0){
            attr(e1, "_outs") <- TRUE
        }
    }
    
    ## first empty one
    if(length(inputs(e1))==0){
        e1@inputs <- stepInputs(list(e2))
        ##e1@outputs <- stepOutputs(list(e2))
    ## if inputs are not pre-defined
    }else if(!all(names(stepInputs(list(e2))) %in% names(inputs(e1)))){
        e1@inputs <- stepInputs(c(e1@steps@listData, e2))
    }
    if(!attr(e1, "_outs")){
        e1@outputs <- stepOutputs(c(e1@steps@listData, e2))
    }
    e1@steps <- do.call(cwlStepList, c(e1@steps@listData, e2))

    return(e1)
})

setGeneric("+")

#' @rdname cwlWorkflow
#' @description steps: Function to extract and assign workflow step
#'     slots.
#' @param cwl A `cwlWorkflow` object.
#' @param value A list of `cwlSteps` to assign.
#' @export
#' @return steps: A list of `cwlStep` objects.
steps <- function(cwl) cwl@steps

#' @rdname cwlWorkflow
#' @export
"steps<-" <- function(cwl, value){
    cwl@steps  <- value
    cwl
}

---
title: "Rcwl: An R interface to the Common Workflow Language (CWL)"
author: "Qiang Hu, Qian Liu"
date: "`r Sys.Date()`"
output:
  BiocStyle::html_document:
    toc: true
    toc_float: true
vignette: >
  %\VignetteIndexEntry{Rcwl: An R interface to the Common Workflow Language}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
<!-- ```{r setup, include = FALSE} -->
<!-- knitr::opts_chunk$set( -->
<!--   collapse = TRUE, -->
<!--   comment = "#>" -->
<!-- ) -->
<!-- ``` -->

```{r setup, include=FALSE}
knitr::opts_knit$set(root.dir = tempdir())
```

Here we introduce the _Bioconductor_ toolchain for usage and development
of reproducible bioinformatics pipelines using packages of
[Rcwl](https://bioconductor.org/packages/Rcwl/) and
[RcwlPipelines](https://bioconductor.org/packages/RcwlPipelines/). 

`Rcwl` provides a simple way to wrap command line tools and build CWL
data analysis pipelines programmatically within _R_. It increases the
ease of use, development, and maintenance of CWL
pipelines. `RcwlPipelines` manages a collection of more than a hundred
of pre-built and tested CWL tools and pipelines, which are highly
modularized with easy customization to meet different bioinformatics
data analysis needs.

In this vignette, we will introduce how to build and run CWL pipelines
within _R/Bioconductor_ using `Rcwl`package. More details about CWL
can be found at <https://www.commonwl.org>.

# Installation

1. Download and install the package. 

```{r getPackage, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("Rcwl")
```

The development version with most up-to-date functionalities is also
available from GitHub.

```{r getDevel, eval=FALSE}
BiocManager::install("rworkflow/Rcwl")
```

2. Load the package into _R_ session.
```{r Load, message=FALSE}
library(Rcwl)
```

# First Example

`cwlProcess` is the main constructor function to wrap a command line
tool into an _R_ tool as a `cwlProcess` object (S4 class).  Let's
start with a simple example to wrap the `echo` command and execute
`echo hello world` in _R_.

First, we need to define the input parameter for the base command
`echo`, here it is a string without a prefix. An `id` argument is
required here.

```{r}
input1 <- InputParam(id = "sth")
```

Second, we can construct a `cwlProcess` object by specifying the
`baseCommand` for the command line tool, and `InputParamList` for the
input parameters. 
```{r}
echo <- cwlProcess(baseCommand = "echo", inputs = InputParamList(input1))
```

Now we have converted the command line tool `echo` into an _R_ tool:
an _R_ object of class `cwlProcess` with the name of `echo`. We can
take a look at the this _R_ object and use some utility functions to
extract specific information.

```{r}
echo
class(echo)
cwlClass(echo)
cwlVersion(echo)
baseCommand(echo)
inputs(echo)
outputs(echo)
```

The `inputs(echo)` will show the value once it is assigned in next
step. Since we didn't define the outputs for this tool, it will stream
standard output to a temporary file by default.

The third step is to assign values (here is "Hello World!") for the
input parameters.

```{r}
echo$sth <- "Hello World!"
inputs(echo)
```

Now this _R_ version of command line tool `echo` is ready to be
executed. 

We can install `cwltool` first to make sure a `cwl-runner` is
available.
```{r}
invisible(install_cwltool())
```

The function `runCWL` runs the tools in _R_ and returns a list of: 1)
actual command line that was executed, 2) filepath to the output, and
3) running logs. The output directory by default takes the working
directory, but can be specified in `outdir` argument.

```{r}
r1 <- runCWL(echo, outdir = tempdir())
r1
r1$command
readLines(r1$output)
r1$logs
```

Users can also have the log printed out by specifying `showLog = TRUE`.

```{r}
r1 <- runCWL(echo, outdir = tempdir(), showLog = TRUE)
```

A utility function `writeCWL` converts the `cwlProcess` object into 2
files: a `.cwl` file for the command and `.yml` file for the inputs,
which are the internal cwl files to be executed when `runCWL` is
invoked. The internal execution requires a `cwl-runner` (e.g.,
`cwltool`), which will be installed automatically with `runCWL`.

```{r}
writeCWL(echo)
```

# Wrap command line tools

The package provides functions to define a CWL syntax for Command Line
Tools in an intuitive way. The functions were developed based on the
CWL Command Line Tool Description (v1.0). More details can be found in
the official document:
<https://www.commonwl.org/v1.0/CommandLineTool.html>.

## Input Parameters
### Essential Input parameters
For the input parameters, three options need to be defined usually,
*id*, *type*, and *prefix*. The type can be *string*, *int*, *long*,
*float*, *double*, and so on. More detail can be found at:
<https://www.commonwl.org/v1.0/CommandLineTool.html#CWLType>.

Here is an example from [CWL user
guide](http://www.commonwl.org/user_guide/03-input/). Here we defined
an `echo` with different type of input parameters by `InputParam`. The
`stdout` option can be used to capture the standard output stream to a
file.

```{r}
e1 <- InputParam(id = "flag", type = "boolean", prefix = "-f")
e2 <- InputParam(id = "string", type = "string", prefix = "-s")
e3 <- InputParam(id = "int", type = "int", prefix = "-i")
e4 <- InputParam(id = "file", type = "File", prefix = "--file=", separate = FALSE)
echoA <- cwlProcess(baseCommand = "echo",
                  inputs = InputParamList(e1, e2, e3, e4),
                  stdout = "output.txt")
```

Then we give it a try by setting values for the inputs.
```{r}
echoA$flag <- TRUE
echoA$string <- "Hello"
echoA$int <- 1

tmpfile <- tempfile()
write("World", tmpfile)
echoA$file <- tmpfile

r2 <- runCWL(echoA, outdir = tempdir())
r2$command
```

The command shows the parameters work as we defined. The parameter
order is in alphabetical by default, but the option of "position" can
be used to fix the orders.

### Array Inputs
A similar example to CWL user guide. We can define three different type of array as inputs. 
```{r}
a1 <- InputParam(id = "A", type = "string[]", prefix = "-A")
a2 <- InputParam(id = "B",
                 type = InputArrayParam(items = "string",
                                        prefix="-B=", separate = FALSE))
a3 <- InputParam(id = "C", type = "string[]", prefix = "-C=",
                 itemSeparator = ",", separate = FALSE)
echoB <- cwlProcess(baseCommand = "echo",
                 inputs = InputParamList(a1, a2, a3))
```

Then set values for the three inputs.
```{r}
echoB$A <- letters[1:3]
echoB$B <- letters[4:6]
echoB$C <- letters[7:9]
echoB
```

Now we can check whether the command behaves as we expected.
```{r}
r3 <- runCWL(echoB, outdir = tempdir())
r3$command
```

## Output Parameters
### Capturing Output
The outputs, similar to the inputs, is a list of output parameters. Three options *id*, *type* and *glob* can be defined. The glob option is used to define a pattern to find files relative to the output directory.

Here is an example to unzip a compressed `gz` file. First, we generate a compressed R script file.
```{r}
zzfil <- file.path(tempdir(), "sample.R.gz")
zz <- gzfile(zzfil, "w")
cat("sample(1:10, 5)", file = zz, sep = "\n")
close(zz)
```

We define a `cwlProcess` object to use "gzip" to uncompress a input file.
```{r}
ofile <- "sample.R"
z1 <- InputParam(id = "uncomp", type = "boolean", prefix = "-d")
z2 <- InputParam(id = "out", type = "boolean", prefix = "-c")
z3 <- InputParam(id = "zfile", type = "File")
o1 <- OutputParam(id = "rfile", type = "File", glob = ofile)
gz <- cwlProcess(baseCommand = "gzip",
               inputs = InputParamList(z1, z2, z3),
               outputs = OutputParamList(o1),
               stdout = ofile)
```

Now the `gz` object can be used to uncompress the previous generated compressed file.
```{r}
gz$uncomp <- TRUE
gz$out <- TRUE
gz$zfile <- zzfil
r4 <- runCWL(gz, outdir = tempdir())
r4$output
```

Or we can use `arguments` to set some default parameters.
```{r}
z1 <- InputParam(id = "zfile", type = "File")
o1 <- OutputParam(id = "rfile", type = "File", glob = ofile)
Gz <- cwlProcess(baseCommand = "gzip",
               arguments = list("-d", "-c"),
               inputs = InputParamList(z1),
               outputs = OutputParamList(o1),
               stdout = ofile)
Gz
Gz$zfile <- zzfil
r4a <- runCWL(Gz, outdir = tempdir())
```

To make it for general usage, we can define a pattern with javascript
to glob the output, which require `node` from "nodejs" to be installed in your
system PATH.

```{r}
pfile <- "$(inputs.zfile.path.split('/').slice(-1)[0].split('.').slice(0,-1).join('.'))"
```

Or we can use the CWL built in file property, `nameroot`, directly.
```{r}
pfile <- "$(inputs.zfile.nameroot)"
o2 <- OutputParam(id = "rfile", type = "File", glob = pfile)
req1 <- requireJS()
GZ <- cwlProcess(baseCommand = "gzip",
               arguments = list("-d", "-c"),
               requirements = list(), ## assign list(req1) if node installed.
               inputs = InputParamList(z1),
               outputs = OutputParamList(o2),
               stdout = pfile)
GZ$zfile <- zzfil
r4b <- runCWL(GZ, outdir = tempdir())
```

### Array Outputs

We can also capture multiple output files with `glob` pattern.

```{r}
a <- InputParam(id = "a", type = InputArrayParam(items = "string"))
b <- OutputParam(id = "b", type = OutputArrayParam(items = "File"),
                 glob = "*.txt")
touch <- cwlProcess(baseCommand = "touch", inputs = InputParamList(a),
                    outputs = OutputParamList(b))
touch$a <- c("a.txt", "b.log", "c.txt")
r5 <- runCWL(touch, outdir = tempdir())
r5$output
```

The "touch" command generates three files, but the output only collects
two files with ".txt" suffix as defined in the `OutputParam` using the
"glob" option.

# Running Tools in Docker

The CWL can work with docker to simplify your software management and
communicate files between host and container. The docker container can
be defined by the `hints` or `requirements` option.

```{r}
d1 <- InputParam(id = "rfile", type = "File")
req1 <- requireDocker("r-base")
doc <- cwlProcess(baseCommand = "Rscript",
                inputs = InputParamList(d1),
                stdout = "output.txt",
                hints = list(req1))
doc$rfile <- r4$output
```
```{r, eval=FALSE}
r6 <- runCWL(doc)
```

The tools defined with docker requirements can also be run locally by
disabling the docker option. In case your `Rscript` depends some local
libraries to run, an option from `cwltools`,
"--preserve-entire-environment", can be used to pass all environment
variables.

```{r}
r6a <- runCWL(doc, docker = FALSE, outdir = tempdir(),
              cwlArgs = "--preserve-entire-environment")
```

# Running Tools in Cluster server
The CWL can also work in high performance clusters with batch-queuing
system, such as SGE, PBS, SLURM and so on, using the Bioconductor
package `BiocParallel`. Here is an example to submit jobs with
"Multicore" and "SGE".

```{r, eval=FALSE}
library(BiocParallel)
sth.list <- as.list(LETTERS)
names(sth.list) <- LETTERS

## submit with multicore
result1 <- runCWLBatch(cwl = echo, outdir = tempdir(), inputList = list(sth = sth.list),
                       BPPARAM = MulticoreParam(26))

## submit with SGE
result2 <- runCWLBatch(cwl = echo, outdir = tempdir(), inputList = list(sth = sth.list),
                       BPPARAM = BatchtoolsParam(workers = 26, cluster = "sge",
                                                 resources = list(queue = "all.q")))
```


# Writing Pipeline

We can connect multiple tools together into a pipeline. Here is an
example to uncompress an R script and execute it with `Rscript`.

Here we define a simple `Rscript` tool without using docker.
```{r}
d1 <- InputParam(id = "rfile", type = "File")
Rs <- cwlProcess(baseCommand = "Rscript",
               inputs = InputParamList(d1))
Rs
```

Test run:
```{r}
Rs$rfile <- r4$output
tres <- runCWL(Rs, outdir = tempdir())
readLines(tres$output)
```

The pipeline includes two steps, decompressing with predefined
`cwlProcess` of `GZ` and compiling with `cwlProcess` of `Rs`. The
input file is a compressed file for the first "Uncomp" step.

```{r}
i1 <- InputParam(id = "cwl_zfile", type = "File")
s1 <- cwlStep(id = "Uncomp", run = GZ,
              In = list(zfile = "cwl_zfile"))
s2 <- cwlStep(id = "Compile", run = Rs,
              In = list(rfile = "Uncomp/rfile"))
```

In step 1 ('s1'), the pipeline runs the `cwlProcess` of `GZ`, where
the input `zfile` is defined in 'i1' with id of "cwl_zfile". In step 2
('s2'), the pipeline runs the `cwlProcess` of `Rs`, where the input
`rfile` is from the output of the step 1 ("Uncomp/rfile") using the
format of `<step>/<output>`.

The pipeline output will be defined as the output of the step 2
("Compile/output") using the format of `<step>/<output>` as shown
below.

```{r}
o1 <- OutputParam(id = "cwl_cout", type = "File",
                  outputSource = "Compile/output")
```

The `cwlWorkflow` function is used to initiate the pipeline by
specifying the `inputs` and `outputs`. Then we can simply use `+` to
connect all steps to build the final pipeline.

```{r}
cwl <- cwlWorkflow(inputs = InputParamList(i1),
                    outputs = OutputParamList(o1))
cwl <- cwl + s1 + s2
cwl
```

Let's run the pipeline.
```{r}
cwl$cwl_zfile <- zzfil
r7 <- runCWL(cwl, outdir = tempdir())
readLines(r7$output)
```

Tips: Sometimes, we need to adjust some arguments of certain tools in
a pipeline besides of parameter inputs. The function `arguments` can
help to modify arguments for a tool, tool in a pipeline, or even tool
in a sub-workflow. For example,

```{r}
arguments(cwl, step = "Uncomp") <- list("-d", "-c", "-f")
runs(cwl)$Uncomp
```


## Scattering pipeline
The scattering feature can specifies the associated workflow step or
subworkflow to execute separately over a list of input elements. To
use this feature, `ScatterFeatureRequirement` must be specified in the
workflow requirements. Different `scatter` methods can be used in the
associated step to decompose the input into a discrete set of
jobs. More details can be found at:
https://www.commonwl.org/v1.0/Workflow.html#WorkflowStep.

Here is an example to execute multiple R scripts. First, we need to
set the input and output types to be array of "File", and add the
requirements. In the "Compile" step, the scattering input is required
to be set with the `scatter` option.

```{r}
i2 <- InputParam(id = "cwl_rfiles", type = "File[]")
o2 <- OutputParam(id = "cwl_couts", type = "File[]", outputSource = "Compile/output")
req1 <- requireScatter()
cwl2 <- cwlWorkflow(requirements = list(req1),
                    inputs = InputParamList(i2),
                    outputs = OutputParamList(o2))
s1 <- cwlStep(id = "Compile", run = Rs,
              In = list(rfile = "cwl_rfiles"),
              scatter = "rfile")
cwl2 <- cwl2 + s1
cwl2
```

Multiple R scripts can be assigned to the workflow inputs and executed.

```{r}
cwl2$cwl_rfiles <- c(r4b$output, r4b$output)
r8 <- runCWL(cwl2, outdir = tempdir())
r8$output
```

## Pipeline plot
The function `plotCWL` can be used to visualize the relationship of
inputs, outputs and the analysis for a tool or pipeline.

```{r}
plotCWL(cwl)
```

# Web Application
## cwlProcess example
Here we build a tool with different types of input parameters.
```{r}
e1 <- InputParam(id = "flag", type = "boolean",
                 prefix = "-f", doc = "boolean flag")
e2 <- InputParam(id = "string", type = "string", prefix = "-s")
e3 <- InputParam(id = "option", type = "string", prefix = "-o")
e4 <- InputParam(id = "int", type = "int", prefix = "-i", default = 123)
e5 <- InputParam(id = "file", type = "File",
                 prefix = "--file=", separate = FALSE)
e6 <- InputParam(id = "array", type = "string[]", prefix = "-A",
                 doc = "separated by comma")
mulEcho <- cwlProcess(baseCommand = "echo", id = "mulEcho",
                 label = "Test parameter types",
                 inputs = InputParamList(e1, e2, e3, e4, e5, e6),
                 stdout = "output.txt")
mulEcho
```


## cwlProcess to Shiny App

Some input parameters can be predefined in a list, which will be
converted to select options in the webapp. An `upload` parameter can
be used to defined whether to generate an upload interface for the
file type option. If FALSE, the upload field will be text input (file
path) instead of file input.

```{r, eval=FALSE}
inputList <- list(option = c("option1", "option2"))
app <- cwlShiny(mulEcho, inputList, upload = TRUE)
runApp(app)
```
![shinyApp](cwlShiny.png)

# Working with R functions
We can wrap an R function to `cwlProcess` object by simply assigning the R function to `baseCommand`. This could be useful to summarize results from other tools in a pipeline. It can also be used to benchmark different parameters for a method written in R. Please note that this feature is only implemented by `Rcwl`, but not available in the common workflow language.

```{r}
fun1 <- function(x)x*2
testFun <- function(a, b){
    cat(fun1(a) + b^2, sep="\n")
}
assign("fun1", fun1, envir = .GlobalEnv)
assign("testFun", testFun, envir = .GlobalEnv)
p1 <- InputParam(id = "a", type = "int", prefix = "a=", separate = F)
p2 <- InputParam(id = "b", type = "int", prefix = "b=", separate = F)
o1 <- OutputParam(id = "o", type = "File", glob = "rout.txt")
TestFun <- cwlProcess(baseCommand = testFun,
                    inputs = InputParamList(p1, p2),
                    outputs = OutputParamList(o1),
                    stdout = "rout.txt")
TestFun$a <- 1
TestFun$b <- 2
r1 <- runCWL(TestFun, cwlArgs = "--preserve-entire-environment")
readLines(r1$output)
```

The `runCWL` function wrote the `testFun` function and its
dependencies into an R script file automatically and call `Rscript` to
run the script with parameters. Each parameter requires a prefix from
corresponding argument in the R function with "=" and without a
separator. Here we assigned the R function and its dependencies into
the global environment because it will start a new environment when
the vignette is compiled.

# Resources

## RcwlPipelines

The `Rcwl` package can be utilized to develop pipelines for best
practices of reproducible research, especially for Bioinformatics
study. Multiple Bioinformatics pipelines, such as RNA-seq alignment,
quality control and quantification, DNA-seq alignment and variant
calling, have been developed based on the tool in an R package
`RcwlPipelines`, which contains the CWL recipes and the scripts to
create the pipelines. Examples to analyze real data are also included.

The package is currently available in GitHub.

* <https://github.com/rworkflow/RcwlPipelines>

To install the package.
```{r, eval=FALSE}
BiocManager::install("rworkflow/RcwlPipelines")
```

The project website https://rcwl.org/ serves as a central hub for all
related resources. It provides guidance for new users and tutorials
for both users and developers. Specific resources are listed below. 

## Tutorial book

The [tutorial book](https://rcwl.org/RcwlBook/) provides detailed
instructions for developing `Rcwl` tools/pipelines, and also includes
examples of some commonly-used tools and pipelines that covers a wide
range of Bioinformatics data analysis needs.

## The _R_ recipes and cwl scripts

The _R_ scripts to build the CWL tools and pipelines are now residing
in a dedicated [GitHub
repository](https://github.com/rworkflow/RcwlRecipes), which is
intended to be a community effort to collect and contribute
Bioinformatics tools and pipelines using `Rcwl` and CWL.

## Tool collections in CWL format

Plenty of Bioinformatics tools and workflows can be found from GitHub
in CWL format. They can be imported to `cwlProcess` object by
`readCWL` function, or can be used directly.

* <https://github.com/common-workflow-library/bio-cwl-tools>
* <https://github.com/Duke-GCB/GGR-cwl>
* <https://github.com/pitagora-network/pitagora-cwl> 

## Docker for Bioinformatics tools

Most of the Bioinformatics software are available in docker
containers, which can be very convenient to be adopted to build
portable CWL tools and pipelines.

* <https://dockstore.org>
* <https://biocontainers.pro>
		
# SessionInfo
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwlWorkflow.R
\name{cwlWorkflow}
\alias{cwlWorkflow}
\alias{+,cwlWorkflow,cwlStep-method}
\alias{steps}
\alias{steps<-}
\title{cwlWorkflow function}
\usage{
cwlWorkflow(
  cwlVersion = "v1.0",
  cwlClass = "Workflow",
  requirements = list(),
  id = character(),
  label = character(),
  doc = character(),
  intent = list(),
  hints = list(),
  arguments = list(),
  extensions = list(),
  inputs = InputParamList(),
  outputs = OutputParamList(),
  steps = cwlStepList()
)

\S4method{+}{cwlWorkflow,cwlStep}(e1, e2)

steps(cwl)

steps(cwl) <- value
}
\arguments{
\item{cwlVersion}{CWL version}

\item{cwlClass}{"Workflow".}

\item{requirements}{Requirements that apply to either the runtime
environment or the workflow engine.}

\item{id}{A user-defined unique identifier for this workflow.}

\item{label}{A short, human-readable label of this object.}

\item{doc}{A documentation string for this object.}

\item{intent}{An identifier for the type of computational
operation, of this Process.}

\item{hints}{Any or a list for the workflow engine.}

\item{arguments}{Command line bindings which are not directly
associated with input parameters.}

\item{extensions}{A list of extensions and metadata.}

\item{inputs}{An object of `InputParamList`.}

\item{outputs}{An object of `OutputParamList`.}

\item{steps}{A list of `cwlStepList`.}

\item{e1}{A `cwlWorkflow` object.}

\item{e2}{A `cwlStep` object.}

\item{cwl}{A `cwlWorkflow` object.}

\item{value}{A list of `cwlSteps` to assign.}
}
\value{
cwlWorkflow: An object of class `cwlWorkflow`.

steps: A list of `cwlStep` objects.
}
\description{
The constructor function for `cwlWorkflow` object,
    which connects multiple command line steps into a workflow.

steps: Function to extract and assign workflow step
    slots.
}
\examples{
input1 <- InputParam(id = "sth")
echo1 <- cwlProcess(baseCommand = "echo",
                  inputs = InputParamList(input1))
input2 <- InputParam(id = "sthout", type = "File")
echo2 <- cwlProcess(baseCommand = "echo",
                  inputs = InputParamList(input2),
                  stdout = "out.txt")
i1 <- InputParam(id = "sth")
o1 <- OutputParam(id = "out", type = "File", outputSource = "echo2/output")
wf <- cwlWorkflow(inputs = InputParamList(i1),
                   outputs = OutputParamList(o1))
s1 <- cwlStep(id = "echo1", run = echo1, In = list(sth = "sth"))
s2 <- cwlStep(id = "echo2", run = echo2, In = list(sthout = "echo1/output"))
wf <- wf + s1 + s2
}
\seealso{
\code{\link{stepInParamList}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runCWL.R
\name{runCWL}
\alias{runCWL}
\title{run cwlProcess}
\usage{
runCWL(
  cwl,
  outdir = ".",
  cwlRunner = "cwltool",
  cachedir = NULL,
  cwlTemp = NULL,
  cwlArgs = character(),
  stdout = TRUE,
  stderr = TRUE,
  showLog = FALSE,
  docker = TRUE,
  conda = FALSE,
  yml_prefix = deparse(substitute(cwl)),
  yml_outdir = tempfile(),
  ...
)
}
\arguments{
\item{cwl}{A `cwlProcess` or `cwlWorkflow` object.}

\item{outdir}{Output directory, default is current working
directory.}

\item{cwlRunner}{The path to the `cwltool` or `cwl-runner`. If not
exists, the cwltool package will be installed by `reticulate`.}

\item{cachedir}{Directory to cache intermediate workflow outputs to
avoid recomputing steps.}

\item{cwlTemp}{File path to keep intermediate files. If a directory
path is given, the intermediate files will be kept in the
directory. Default is NULL to remove all intermediate files.}

\item{cwlArgs}{The arguments for `cwltool` or `cwl-runner`. For
example, "--debug" can work with `cwltool` to show debug
information.}

\item{stdout}{standard output from `system2`.}

\item{stderr}{standard error from `system2`. By setting it to "",
the detailed running logs will return directly.}

\item{showLog}{Whether to show log details to standard
out. i.e. stderr = "".}

\item{docker}{Whether to use docker, or "sigularity" if use
Singularity runtime to run container.}

\item{conda}{Whether to install packages using conda if
`SoftwareRequirement` is defined.}

\item{yml_prefix}{The prefix of `.cwl` and `.yml` files that are to
be internally executed.}

\item{yml_outdir}{The output directory for the `.cwl` and `.yml`
files.}

\item{...}{The other options from `writeCWL` and `system2`.}
}
\value{
A list of outputs from tools and logs from cwltool.
}
\description{
Execute a cwlProcess object with assigned inputs.
}
\examples{
input1 <- InputParam(id = "sth")
echo <- cwlProcess(baseCommand = "echo",
                 inputs = InputParamList(input1))
echo$sth <- "Hello World!"
## res <- runCWL(echo)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{InputArrayParam-class}
\alias{InputArrayParam-class}
\alias{InputArrayParam}
\alias{InputParam-class}
\alias{InputParam}
\alias{InputParamList-class}
\alias{InputParamList}
\alias{OutputArrayParam-class}
\alias{OutputArrayParam}
\alias{OutputParam-class}
\alias{OutputParam}
\alias{OutputParamList-class}
\alias{OutputParamList}
\alias{cwlProcess-class}
\alias{stepInParam-class}
\alias{stepInParam}
\alias{stepInParamList-class}
\alias{stepInParamList}
\alias{cwlStep-class}
\alias{cwlStepList-class}
\alias{cwlStepList}
\alias{cwlWorkflow-class}
\title{All classes defined in the package of `Rcwl` and the class constructor functions.}
\usage{
InputArrayParam(
  label = "",
  doc = character(),
  name = character(),
  type = "array",
  items = character(),
  prefix = "",
  separate = TRUE,
  itemSeparator = character(),
  valueFrom = character()
)

InputParam(
  id,
  label = "",
  type = "string",
  doc = character(),
  secondaryFiles = character(),
  streamable = logical(),
  format = character(),
  loadListing = character(),
  loadContents = logical(),
  position = 0L,
  prefix = "",
  separate = TRUE,
  itemSeparator = character(),
  valueFrom = character(),
  shellQuote = logical(),
  default = character(),
  value = character()
)

InputParamList(...)

OutputArrayParam(
  label = character(),
  doc = character(),
  name = character(),
  type = "array",
  items = character()
)

OutputParam(
  id = "output",
  label = character(),
  doc = character(),
  type = "stdout",
  format = character(),
  secondaryFiles = character(),
  streamable = logical(),
  glob = character(),
  loadContents = logical(),
  loadListing = character(),
  outputEval = character(),
  outputSource = character(),
  linkMerge = character(),
  pickValue = character()
)

OutputParamList(out = OutputParam(), ...)

stepInParam(
  id,
  source = character(),
  linkMerge = character(),
  pickValue = character(),
  loadContents = logical(),
  loadListing = character(),
  default = character(),
  valueFrom = character()
)

stepInParamList(...)

cwlStepList(...)
}
\arguments{
\item{label}{A short, human-readable label of this object.}

\item{doc}{A documentation string for this object, or an array of
strings which should be concatenated.}

\item{name}{The identifier for this type.}

\item{type}{Specify valid types of data that may be assigned to
this parameter.}

\item{items}{Defines the type of the array elements.}

\item{prefix}{Command line prefix to add before the value.}

\item{separate}{If true (default), then the prefix and value must
be added as separate command line arguments; if false, prefix
and value must be concatenated into a single command line
argument.}

\item{itemSeparator}{Join the array elements into a single string
with the elements separated by by itemSeparator.}

\item{valueFrom}{value from string or expression.}

\item{id}{A unique identifier for this workflow input parameter.}

\item{secondaryFiles}{Provides a pattern or expression specifying
files or directories. Only valid when type: File or is an array
of items: File.}

\item{streamable}{A value of true indicates that the file is read
or written sequentially without seeking. Only valid when type:
File or is an array of items: File.}

\item{format}{Only valid when type: File or is an array of items:
File. This is the file format that will be assigned to the
output File object.}

\item{loadListing}{Only valid when type: Directory or is an array
of items: Directory. "no_listing", "shallow_listing" or
"deep_listing".}

\item{loadContents}{Only valid when type: File or is an array of
items: File.}

\item{position}{The position for this parameter.}

\item{shellQuote}{If ShellCommandRequirement is in the requirements
for the current command, this controls whether the value is
quoted on the command line (default is true).}

\item{default}{The default value for this parameter to use if
either there is no source field, or the value produced by the
source is null.}

\item{value}{Assigned value for this parameter}

\item{...}{A list of `cwlStep` objects.}

\item{glob}{Pattern to find files relative to the output directory.}

\item{outputEval}{Evaluate an expression to generate the output
value.}

\item{outputSource}{Specifies one or more workflow parameters that
supply the value of to the output parameter.}

\item{linkMerge}{The method to use to merge multiple inbound links
into a single array.}

\item{pickValue}{The method to use to choose non-null elements
among multiple sources. "first_non_null", "the_only_non_null",
or "all_non_null".}

\item{out}{The default stdout parameter.}

\item{source}{Specifies one or more workflow parameters that will
provide input to the underlying step parameter.}
}
\value{
InputArrayParam: An object of class `InputArrayParam`.

An object of class `InputParam`.

InputParamList: An object of class `InputParamList`.

An object of class `OutputArrayParam`.

OutputParam: An object of class `OutputParam`.

OutputParamList: An object of class `OutputParamList`.

stepInParam: An object of class `stepInParam`.

An object of class `stepInParamList`.

cwlStepList: An object of class `cwlStepList`.
}
\description{
InputArrayParam: Parameters for array inputs. To
    specify an array parameter, the array definition is nested
    under the type field with 'type: array' and items defining the
    valid data types that may appear in the array.

InputParam: parameter for a command line tool.

InputParamList: A list of `InputParam` objects.

OutputArrayParam: Parameters for array outputs.

OutputParam: An output parameter for a Command Line
    Tool.

OutputParamList: A list of `InputParam` objects.

stepInParam: The input parameter of a workflow step.

stepInParamList: A list of `stepInParam` objects.

cwlStepList: A list of `cwlStep` objects.
}
\details{
More details of `InputArrayParam`, see:
    https://www.commonwl.org/v1.0/CommandLineTool.html#CommandInputArraySchema

More details for `InputParam`, see:
    https://www.commonwl.org/v1.0/CommandLineTool.html#CommandInputParameter

More details for `OutputArrayParam`, see:
    https://www.commonwl.org/v1.0/CommandLineTool.html#CommandOutputArraySchema

More details for `OutputParam`, see:
    https://www.commonwl.org/v1.0/CommandLineTool.html#CommandOutputParameter

More details for `stepInParam`, see:
    https://www.commonwl.org/v1.0/Workflow.html#WorkflowStepInput
}
\examples{
InputArrayParam(items = "string", prefix="-B=", separate = FALSE)
input1 <- InputParam(id = "sth")
InputParamList(input1)
OutputParam(id = "b", type = OutputArrayParam(items = "File"), glob = "*.txt")
o1 <- OutputParam(id = "file", type = "File", glob = "*.txt")
o1

o1 <- OutputParam(id = "file", type = "File", glob = "*.txt")
OutputParamList(o1)
s1 <- stepInParam(id = "s1")

s1 <- stepInParam(id = "s1")
stepInParamList(s1)
s1 <- cwlStep(id = "s1")
cwlStepList(s1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCWL.R
\name{plotCWL}
\alias{plotCWL}
\title{plotCWL}
\usage{
plotCWL(cwl, output = "graph", layout = "tree", ...)
}
\arguments{
\item{cwl}{A cwlWorkflow object to plot}

\item{output}{A string specifying the output type. An option
inherits from `render_graph` and can also be "mermaid".}

\item{layout}{Layout from `render_graph`.}

\item{...}{other parameters from `mermaid` or `render_graph`
function}
}
\value{
A workflow plot.
}
\description{
Function to plot cwlWorkflow object.
}
\examples{
input1 <- InputParam(id = "sth")
echo1 <- cwlProcess(baseCommand = "echo",
                  inputs = InputParamList(input1))
input2 <- InputParam(id = "sthout", type = "File")
echo2 <- cwlProcess(baseCommand = "echo",
                  inputs = InputParamList(input2),
                  stdout = "out.txt")
i1 <- InputParam(id = "sth")
o1 <- OutputParam(id = "out", type = "File", outputSource = "echo2/output")
wf <- cwlWorkflow(inputs = InputParamList(i1),
                   outputs = OutputParamList(o1))
s1 <- cwlStep(id = "echo1", run = echo1, In = list(sth = "sth"))
s2 <- cwlStep(id = "echo2", run = echo2, In = list(sthout = "echo1/output"))
wf <- wf + s1 + s2
plotCWL(wf)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwlShiny.R
\name{cwlShiny}
\alias{cwlShiny}
\title{cwlShiny}
\usage{
cwlShiny(cwl, inputList = list(), upload = FALSE, ...)
}
\arguments{
\item{cwl}{A cwlProcess object.}

\item{inputList}{a list of choices for the inputs of cwl
object. The name of the list must match the inputs of the cwl
object.}

\item{upload}{Whether to upload file. If FALSE, the upload field
will be text input (file path) instead of file input.}

\item{...}{More options for `runCWL`.}
}
\value{
A shiny webapp.
}
\description{
Function to generate shiny app automaticlly for a `cwlProcess`
object.
}
\examples{
input1 <- InputParam(id = "sth")
echo <- cwlProcess(baseCommand = "echo", inputs = InputParamList(input1))
echoApp <- cwlShiny(echo)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwlProcessWorkflow-methods.R
\name{cwlWorkflow-methods}
\alias{cwlWorkflow-methods}
\alias{runs}
\title{cwlWorkflow methods}
\usage{
runs(object)
}
\arguments{
\item{object}{A `cwlWorkflow` object.}
}
\value{
`cwlProcess` objects or paths of CWL file.
}
\description{
runs: The function to access all runs of a `cwlWorkflow` object.
}
\examples{
s1 <- cwlWorkflow()
runs(s1)
s1
short(s1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwl-requirements.R
\name{cwl-requirements}
\alias{cwl-requirements}
\alias{requireDocker}
\alias{requireJS}
\alias{requireSoftware}
\alias{condaPackage}
\alias{requireInitialWorkDir}
\alias{Dirent}
\alias{requireManifest}
\alias{requireSubworkflow}
\alias{requireScatter}
\alias{requireMultipleInput}
\alias{requireStepInputExpression}
\alias{requireEnvVar}
\alias{requireRscript}
\alias{requireResource}
\alias{requireShellCommand}
\alias{requireShellScript}
\alias{ShellScript}
\alias{CondaTool}
\alias{requireNetwork}
\title{CWL requirements functions}
\usage{
requireDocker(
  docker = NULL,
  Load = NULL,
  File = NULL,
  Import = NULL,
  ImageId = NULL,
  OutputDir = NULL
)

requireJS(expressionLib = list())

requireSoftware(packages = list())

condaPackage(package, source = "bioconda", version = NULL)

requireInitialWorkDir(listing = list())

Dirent(entryname = character(), entry, writable = FALSE)

requireManifest(inputID, sep = "\\\\n")

requireSubworkflow()

requireScatter()

requireMultipleInput()

requireStepInputExpression()

requireEnvVar(envlist)

requireRscript(rscript)

requireResource(
  coresMin = NULL,
  coresMax = NULL,
  ramMin = NULL,
  ramMax = NULL,
  tmpdirMin = NULL,
  tmpdirMax = NULL,
  outdirMin = NULL,
  outdirMax = NULL
)

requireShellCommand()

requireShellScript(script)

ShellScript(shell = "bash", script = "script.sh")

CondaTool(tools)

requireNetwork(networkAccess = TRUE)
}
\arguments{
\item{docker}{Character. Specify a Docker image to retrieve using
docker pull.}

\item{Load}{Character. Specify a HTTP URL from which to download a
Docker image using docker load.}

\item{File}{Character. Supply the contents of a Dockerfile which will
be built using docker build.}

\item{Import}{Character. Provide HTTP URL to download and gunzip a
Docker images using `docker import.}

\item{ImageId}{Character. The image id that will be used for docker
run. May be a human-readable image name or the image identifier
hash. May be skipped if dockerPull is specified, in which case
the dockerPull image id must be used.}

\item{OutputDir}{Character. Set the designated output directory to a
specific location inside the Docker container.}

\item{expressionLib}{optional list. Additional code fragments that
will also be inserted before executing the expression
code. Allows for function definitions that may be called from
CWL expressions.}

\item{packages}{The list of software to be configured.}

\item{package}{The software name.}

\item{source}{The source of software in anaconda. `bioconda` is
used by default.}

\item{version}{The version of software.}

\item{listing}{The list of files or subdirectories that must be
placed in the designated output directory prior to executing
the command line tool.}

\item{entryname}{Character or Expression. The name of the file or
subdirectory to create in the output directory. The name of the
file or subdirectory to create in the output directory. If
entry is a File or Directory, the entryname field overrides the
value of basename of the File or Directory object. Optional.}

\item{entry}{Charactor or expression. Required.}

\item{writable}{Logical. If true, the file or directory must be
writable by the tool. Changes to the file or directory must be
isolated and not visible by any other CommandLineTool
process. Default is FALSE (files and directories are
read-only). Optional.}

\item{inputID}{The input ID from corresponding `InputParam`.}

\item{sep}{The separator of the input files in the manifest config.}

\item{envlist}{A list of environment variables.}

\item{rscript}{An R script to run.}

\item{coresMin}{Minimum reserved number of CPU cores (default is
1).}

\item{coresMax}{Maximum reserved number of CPU cores.}

\item{ramMin}{Minimum reserved RAM in mebibytes (2**20) (default is
256).}

\item{ramMax}{Maximum reserved RAM in mebibytes (2**20)}

\item{tmpdirMin}{Minimum reserved filesystem based storage for the
designated temporary directory, in mebibytes (2**20) (default
is 1024).}

\item{tmpdirMax}{Maximum reserved filesystem based storage for the
designated temporary directory, in mebibytes (2**20).}

\item{outdirMin}{Minimum reserved filesystem based storage for the
designated output directory, in mebibytes (2**20) (default is
1024).}

\item{outdirMax}{Maximum reserved filesystem based storage for the
designated output directory, in mebibytes (2**20).}

\item{script}{script.sh}

\item{shell}{Default shell.}

\item{tools}{A character vector for tools to install by conda.}

\item{networkAccess}{TRUE or FALSE.}
}
\value{
requireDocker: A list of docker requirement to fetch or
    build the image.

requireJS: A list of inline Javascript requirement.

requireSoftware: A list of software requirements.

A list of software package.

requireInitialWorkDir: A list of initial work directory requirements.

Dirent: A list.

requireSubworkflow: A SubworkflowFeatureRequirement list.

rquireScatter: A ScatterFeatureRequirement list.

requireMultipleInput: A MultipleInputFeatureRequirement list.

requireStepInputExpression: A StepInputExpressionRequirement list.

requireEnvVar: A EnvVarRequirementlist.

A requirement list with Rscript as manifest entry.

ResourceRequirement: A ResourceRequirement list.

ShellCommandRequirement: A ShellCommandRequirement list.

requireShellScript: Initial directory with shell script.

baseCommand for shell script

CondaTool: Dockerfile

requireNetwork: a list of NetworkAccess requirement.
}
\description{
requireDocker: If a workflow component should be run
    in a Docker container, this function specifies how to fetch or
    build the image.

requireJS: Indicates that the workflow platform must
    support inline Javascript expressions. If this requirement is
    not present, the workflow platform must not perform expression
    interpolatation.

requireSoftware: A list of software packages that
    should be configured in the environment of the defined process.

SoftwarePackage from anaconda.

InitialWorkDirRequirement: Define a list of files and
    subdirectories that must be created by the workflow platform in
    the designated output directory prior to executing the command
    line tool.

: Dirent: Define a file or subdirectory that must be
    placed in the designated output directory prior to executing
    the command line tool. May be the result of executing an
    expression, such as building a configuration file from a
    template.

Create manifest for configure files.

requireShellScript: create shell script to work dir.

CondaTool: create dockerfile for tools.

requireNetwork: Whether a process requires network
    access.
}
\details{
More details about `requireDocker`, see:
    https://www.commonwl.org/v1.0/CommandLineTool.html#DockerRequirement

More details about `requireJS`, see:
    https://www.commonwl.org/v1.0/CommandLineTool.html#InlineJavascriptRequirement

More details about `requireSoftware`, see:
    https://www.commonwl.org/v1.0/CommandLineTool.html#SoftwareRequirement

More details about `requireSoftware`, see:
    https://www.commonwl.org/v1.0/CommandLineTool.html#SoftwarePackage

More details about `requireInitialWorkDir`, See:
    https://www.commonwl.org/v1.0/CommandLineTool.html#InitialWorkDirRequirement

More details about `Dirent`,
    See:https://www.commonwl.org/v1.0/CommandLineTool.html#Dirent
}
\examples{
p1 <- InputParam(id = "ifiles", type = "File[]?", position = -1)
CAT <- cwlProcess(baseCommand = "cat",
       requirements = list(requireDocker("alpine"), requireManifest("ifiles"), requireJS()),
       arguments = list("ifiles"),
       inputs = InputParamList(p1))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwlStep.R
\name{stepInputs}
\alias{stepInputs}
\title{stepInputs}
\usage{
stepInputs(stepList)
}
\arguments{
\item{stepList}{a list of `cwlStep` objects.}
}
\value{
InputParamList.
}
\description{
prepare inputs for workflow from `cwlStep` objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runCWL.R
\name{runCWLBatch}
\alias{runCWLBatch}
\title{run CWL with batchtools}
\usage{
runCWLBatch(
  cwl,
  outdir = getwd(),
  inputList,
  paramList = list(),
  BPPARAM = BatchtoolsParam(workers = lengths(inputList)[1]),
  ...
)
}
\arguments{
\item{cwl}{A `cwlProcess` or `cwlWorkflow` object.}

\item{outdir}{Directory to output results}

\item{inputList}{An input list to run in parallel. The list names
must be in the inputs of cwl. Jobs will be submitted in
parallel for each element in the list. The output directory of
each job will be made using the name of each element under the
`outdir`.}

\item{paramList}{A parameter list for the cwl. The list names must
be in the inputs of cwl.}

\item{BPPARAM}{The options for `BiocParallelParam`.}

\item{...}{The options from runCWL.}
}
\value{
Results from computing nodes and logs from cwltool.
}
\description{
run CWL with batchtools
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runCWL.R
\name{runCWLBP}
\alias{runCWLBP}
\title{run CWL with BiocParallel}
\usage{
runCWLBP(cwl, outdir, BPPARAM, ...)
}
\arguments{
\item{cwl}{cwl A `cwlProcess` or `cwlWorkflow` object.}

\item{outdir}{Directory for output results}

\item{BPPARAM}{The options for `BiocParallelParam`.}

\item{...}{The other options from runCWL.}
}
\value{
Results from computing nodes and logs from cwltool.
}
\description{
Submit one CWL object with assigned values with BiocParallel.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/writeCWL.R
\name{writeCWL}
\alias{writeCWL}
\title{Write CWL}
\usage{
writeCWL(
  cwl,
  prefix = deparse(substitute(cwl)),
  outdir = tempfile(),
  docker = TRUE,
  libPaths = TRUE,
  ...
)
}
\arguments{
\item{cwl}{A `cwlProcess` or `cwlWorkflow` object.}

\item{prefix}{The prefix of `.cwl` and `.yml` files to be generated.}

\item{outdir}{The output directory for the `.cwl` and `.yml` files.}

\item{docker}{Whether to use docker.}

\item{libPaths}{Whether to add local R libaray paths to R script.}

\item{...}{Other options from `yaml::write_yaml`.}
}
\value{
A CWL file and A YML file.
}
\description{
write `cwlProcess` to cwl and yml.
}
\examples{
input1 <- InputParam(id = "sth")
echo <- cwlProcess(baseCommand = "echo",
                 inputs = InputParamList(input1))
writeCWL(echo)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCWL.R
\name{readCWL}
\alias{readCWL}
\title{Read CWL
Function to read CWL command or workflow files.}
\usage{
readCWL(cwlfile)
}
\arguments{
\item{cwlfile}{The cwl file to read.}
}
\value{
A object of class `cwlProcess` or `cwlWorkflow`.
}
\description{
Read CWL
Function to read CWL command or workflow files.
}
\examples{
input1 <- InputParam(id = "sth")
echo <- cwlProcess(baseCommand = "echo",
                 inputs = InputParamList(input1))
tf <- writeCWL(echo)
readCWL(tf[1])
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcwl-package.R
\name{Rcwl-package}
\alias{Rcwl-package}
\alias{Rcwl}
\alias{Rcwl,Rcwl-package}
\title{Rcwl-package}
\description{
An R package to wrap command line tools and build pipelines with
Common Workflow Language (CWL).
_PACKAGE
}
\seealso{
\code{\link{cwlProcess}}

\code{\link{cwlWorkflow}}

\code{\link{cwlStep}}

\code{\link{runCWL}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwlProcessWorkflow-methods.R
\name{cwlProcess-methods}
\alias{cwlProcess-methods}
\alias{cwlVersion}
\alias{cwlVersion<-}
\alias{cwlClass}
\alias{cwlClass<-}
\alias{baseCommand}
\alias{baseCommand<-}
\alias{arguments}
\alias{arguments<-}
\alias{hints}
\alias{hints<-}
\alias{requirements}
\alias{requirements<-}
\alias{inputs}
\alias{$,cwlProcess-method}
\alias{$<-,cwlProcess-method}
\alias{outputs}
\alias{stdOut}
\alias{stdOut<-}
\alias{extensions}
\alias{extensions<-}
\alias{short}
\title{cwlProcess methods}
\usage{
cwlVersion(cwl)

cwlVersion(cwl) <- value

cwlClass(cwl)

cwlClass(cwl) <- value

baseCommand(cwl)

baseCommand(cwl) <- value

arguments(cwl, step = NULL)

arguments(cwl, step = NULL) <- value

hints(cwl)

hints(cwl) <- value

requirements(cwl, step = NULL)

requirements(cwl, step = NULL) <- value

inputs(cwl)

\S4method{$}{cwlProcess}(x, name)

\S4method{$}{cwlProcess}(x, name) <- value

outputs(cwl)

stdOut(cwl)

stdOut(cwl) <- value

extensions(cwl)

extensions(cwl) <- value

short(cwl)
}
\arguments{
\item{cwl}{A `cwlProcess` (or `cwlWorkflow`) object.}

\item{value}{To assign a list of `requirements` value.}

\item{step}{To specifiy a step ID when `cwl` is a workflow.}

\item{x}{A `cwlProcess` object.}

\item{name}{One of input list.}
}
\value{
cwlVersion: cwl document version

cwlClass: CWL class of `cwlProcess` or `cwlWorkflow` object.

baseCommand: base command for the `cwlProcess` object.

arguments: CWL arguments.

hints: CWL hints.

requirements: CWL requirments.

inputs: A list of `InputParam`.

`$`: the `InputParam` value for `cwlProcess` object.

outputs: A list of `OutputParam`.

stdOut: CWL stdout.

extensions: A list of extensions or metadata.

short: A short summary of an object of `cwlProcess` or `cwlWorkflow`.
}
\description{
Some useful methods for `cwlProcess` objects.

`$`: Extract input values for `cwlProcess`
    object. (Can auto-complete the input names using tab)

`$<-`: Set input values for `cwlProcess` object by name.

outputs: The outputs of a `cwlProcess` object.

stdOut: stdout of `cwlProcess` object.

extensions: Extensions and metadata of `cwlProcess` object.

short: The function to show a short summary of `cwlProcess` or
`cwlWorkflow` object.
}
\examples{
ip <- InputParam(id = "sth")
echo <- cwlProcess(baseCommand = "echo", inputs = InputParamList(ip))
cwlVersion(echo)
cwlClass(echo)
baseCommand(echo)
hints(echo)
requirements(echo)
inputs(echo)
outputs(echo)
stdOut(echo)
extensions(echo)

s1 <- cwlWorkflow()
runs(s1)
s1
short(s1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwlStep.R
\name{stepOutputs}
\alias{stepOutputs}
\title{stepOutputs}
\usage{
stepOutputs(stepList)
}
\arguments{
\item{stepList}{a list of `cwlStep` objects.}
}
\value{
OutputParamList.
}
\description{
prepare outputs for workflow from `cwlStep` objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwlProcess.R
\name{cwlProcess}
\alias{cwlProcess}
\title{Parameters for CWL}
\usage{
cwlProcess(
  cwlVersion = "v1.0",
  cwlClass = "CommandLineTool",
  baseCommand = character(),
  requirements = list(),
  hints = list(),
  arguments = list(),
  id = character(),
  label = character(),
  doc = character(),
  inputs = InputParamList(),
  outputs = OutputParamList(),
  stdout = character(),
  stdin = character(),
  expression = character(),
  extensions = list(),
  intent = list()
)
}
\arguments{
\item{cwlVersion}{CWL version}

\item{cwlClass}{"CommandLineTool"}

\item{baseCommand}{Specifies the program or R function to execute}

\item{requirements}{A list of requirements that apply to either the
runtime environment or the workflow engine that must be met in
order to execute this process.}

\item{hints}{Any or a list for the workflow engine.}

\item{arguments}{Command line bindings which are not directly
associated with input parameters.}

\item{id}{The unique identifier for this process object.}

\item{label}{A short, human-readable label of this process object.}

\item{doc}{A documentation string for this object, or an array of
strings which should be concatenated.}

\item{inputs}{A object of `InputParamList`.}

\item{outputs}{A object of `OutputParamList`.}

\item{stdout}{Capture the command's standard output stream to a
file written to the designated output directory.}

\item{stdin}{A path to a file whose contents must be piped into the
command's standard input stream.}

\item{expression}{Javascripts for ExpressionTool class.}

\item{extensions}{A list of extensions and metadata}

\item{intent}{An identifier for the type of computational
operation, of this Process.}
}
\value{
A `cwlProcess` class object.
}
\description{
The main CWL parameter class and constructor for command
tools. More details:
https://www.commonwl.org/v1.0/CommandLineTool.html
}
\details{
https://www.commonwl.org/v1.0/CommandLineTool.html
}
\examples{
input1 <- InputParam(id = "sth")
echo <- cwlProcess(baseCommand = "echo", inputs = InputParamList(input1))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cwlStep.R
\name{cwlStep}
\alias{cwlStep}
\title{cwlStep function}
\usage{
cwlStep(
  id,
  run = cwlProcess(),
  In = list(),
  Out = list(),
  scatter = character(),
  scatterMethod = character(),
  label = character(),
  doc = character(),
  requirements = list(),
  hints = list(),
  when = character()
)
}
\arguments{
\item{id}{A user-defined unique identifier for this workflow step.}

\item{run}{A `cwlProcess` object for command line tool, or path to
a CWL file.}

\item{In}{A list of input parameters which will be constructed into
`stepInParamList`.}

\item{Out}{A list of outputs.}

\item{scatter}{character or a list. The inputs to be scattered.}

\item{scatterMethod}{required if scatter is an array of more than
one element. It can be one of "dotproduct",
"nested_crossproduct" and "flat_crossproduct".}

\item{label}{A short, human-readable label of this object.}

\item{doc}{A documentation string for this object, or an array of
strings which should be concatenated.}

\item{requirements}{Requirements that apply to either the runtime
environment or the workflow engine.}

\item{hints}{Hints applying to either the runtime environment or
the workflow engine.}

\item{when}{If defined, only run the step when the expression
evaluates to true. If false the step is skipped.}
}
\value{
An object of class `cwlStep`.
}
\description{
Constructor function for `cwlStep` object.
}
\details{
For more details:
    https://www.commonwl.org/v1.0/Workflow.html#WorkflowStep
}
\examples{
s1 <- cwlStep(id = "s1")
}
\seealso{
\code{\link{cwlWorkflow}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meta.R
\name{meta}
\alias{meta}
\alias{meta<-}
\alias{addMeta}
\title{addMeta
Add or change meta information for a cwl recipe.}
\usage{
meta(cwl)

meta(cwl) <- value

addMeta(
  cwl,
  label = character(),
  doc = character(),
  inputLabels = character(),
  inputDocs = character(),
  outputLabels = character(),
  outputDocs = character(),
  stepLabels = character(),
  stepDocs = character(),
  extensions = list()
)
}
\arguments{
\item{cwl}{`cwlProcess` object for data or tool
recipe. `cwlWorkflow` object for a pipeline recipe.}

\item{value}{A list of meta information to add to `cwl`.}

\item{label}{Character string specifying a label for the
recipe. E.g., "bwa align", "gencode annotation".}

\item{doc}{Character string describing the recipe. E.g,
"Align reads to reference genome".}

\item{inputLabels}{Vector of character string, specifying labels
for each input parameter.}

\item{inputDocs}{Vector of character string as descriptions for
each input parameter.}

\item{outputLabels}{Vector of character string, specifying labels
for each output parameter.}

\item{outputDocs}{Vector of character string as descriptions for
each output parameter.}

\item{stepLabels}{Vector of character string, specifying labels for
each step. Use only if `cwl` is a `cwlWorkflow` object.}

\item{stepDocs}{Vector of character string as description for each
step. Use only if `cwl` is a `cwlWorkflow` object.}

\item{extensions}{A list of character strings. Can be used to add
meta information about the recipe. Generally, add fields of
information that does not require execution as part of the
recipe evaluation. for information about "author", "url",
"date", "example", use the exact names as list names as shown
in examples, so that they can be correctly passed into
corresponding fields in markdown file when using
`meta2md`. Other information can be added as a list element
with arbitrary names.}
}
\value{
`meta()`: return a list of all available meta information
    for the `cwl` object.

`addMeta()`: `cwlProcess` or `cwlWorkflow` object, with added meta
    information, which can be returned using `meta(cwl)`. Meta
    information can be converted into markdown file with `meta2md`
    function.
}
\description{
addMeta
Add or change meta information for a cwl recipe.
}
\examples{
\dontrun{
library(RcwlPipelines)
cwlSearch(c("bwa", "align"))
bwaAlign <- RcwlPipelines::cwlLoad("pl_bwaAlign")
bwaAlign <- addMeta(
  cwl = bwaAlign,
  label = "align",
  doc = "align reads to reference genome",
  inputLabels = c("threads", "readgroup", "reference", "read1", "read2"),
  inputDocs = c("number of threads", "read groups",
                "reference genome", "read pair1", "read pair2"),
  outputLabels = c("Bam", "Idx"),
  outputDocs = c("outputbam file", "index file"),
  stepLabels = c(bwa = "bwa"),
  stepDocs = c(bwa = "bwa alignment"))
cat(meta2md(bwaAlign))
}

\dontrun{
rcp <- ReUseData::recipeLoad("gencode_annotation")
meta(rcp)
rcp1 <- addMeta(
  cwl = rcp,
  label = "",
  doc = "An empty description line", 
  inputLabels = c("input label1", "input label2"),
  inputDocs = c("input description 1", "input description 2"), 
  outputLabels = c("output label1"),
  outputDocs = c("output description 1"), 
  extensions = list(
    author = "recipe author's name",
    url = "http://ftp.ebi.ac.uk/pub/databases/gencode/",
    date = as.character(Sys.Date()),
    example = "An example"))
meta(rcp1)
cat(meta2md(rcp1))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basilisk.R
\docType{data}
\name{env_Rcwl}
\alias{env_Rcwl}
\title{Rcwl conda environment}
\format{
An object of class \code{BasiliskEnvironment} of length 1.
}
\usage{
env_Rcwl
}
\description{
Rcwl conda envrionment to install `cwltool` by basilisk.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/install_udocker.R
\name{install_udocker}
\alias{install_udocker}
\title{install udocker}
\usage{
install_udocker(version = "1.3.4")
}
\arguments{
\item{version}{The version of udocker.}
}
\description{
To download and install udocker for python3.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/install_cwltool.R
\name{install_cwltool}
\alias{install_cwltool}
\title{install cwltool}
\usage{
install_cwltool()
}
\description{
To download and install cwltool using basilisk
}
